      PROGRAM MAIN_01 

      IMPLICIT NONE
#     include "txpar.inc" 
#     include "txpro.inc" 
      CHARACTER*12 FRAME, BEAM, TARGET
      DOUBLE PRECISION Ecm     ! CMS energy
      INTEGER I
*
C...EXTERNAL statement links PYDATA on most machines.
      EXTERNAL PYDATA
*
      INTEGER          KCHG, MSTP, MSTI
      DOUBLE PRECISION PMAS, PARF, VCKM, PARP, PARI
      COMMON /PYDAT2/ KCHG(500,4),PMAS(500,4),PARF(2000),VCKM(4,4)
      COMMON /PYPARS/ MSTP(200),PARP(200),MSTI(200),PARI(200)

      FRAME  = 'USER'
      BEAM   = 'P'
      TARGET = 'P'
       Ecm    =  14000.d0     ! LHC cms energy (in GeV)
       txsel = 1
*      txpro(20) = 1  !tt~ production
      PMAS(6,1)  = 175.d0     ! top mass
      PMAS(24,1) =  80.41d0   ! W mass
      MSTP(51) = 8            ! PDF: CTEQ5L
      CALL TopReX(FRAME, BEAM, TARGET, Ecm)  ! TopRex initialisation
      CALL PYINIT(FRAME,BEAM,TARGET, Ecm)
       do I = 1,10 
        print*,'Event number I=',I
        CALL PYEVNT
c...    at this place analysis routines and/or
c...    detector simulations may be called
      ENDDO
       CALL PYSTAT(1)   ! Brief statistics output from PYTHIA
      END




*-------------
