*----------------------------------------------------------------------------*
      FUNCTION APMP0(S,T,U,EMZ2,EQ2,B,A2PB2,A2MB2)
      IMPLICIT REAL*8(A-H,O-Z)
      double complex APMP0
      COMPLEX*16 BI(4),CI(4),DI(3)
      COMMON/CINTS/BI,CI,DI
      Y=U*T-EMZ2**2
      S4=S-4.D0*EMZ2
      S2=S-2.D0*EMZ2
      T1=T-EMZ2
      U1=U-EMZ2
      FAC=DSQRT(2.D0*S4*EMZ2/Y)
      APMP0=A2PB2*FAC/S4*
     1 (2.D0*S**2/Y*
     2  ((U**2+T**2)*CI(1)+S2*S4*CI(4)
     3   -2.D0*U**3/U1*CI(3)-2.D0*T**3/T1*CI(2)
     4   -U**3*DI(2)-T**3*DI(1))*(1.D0+B*(T-U)/S4)
     5  +4.D0*S*Y/U1/T1*(1.D0-B*(T-U)/S4)
     6  +4.D0*((U1**2*(U+EMZ2)*(1.D0+B*S/S4)
     7         +EMZ2*S*U*(1.D0-B*(T-U)/S4))/U1**2*BI(3)
     8        +(T1**2*(T+EMZ2)*(1.D0-B*S/S4)
     9         +EMZ2*S*T*(1.D0-B*(T-U)/S4))/T1**2*BI(2)
     1        +S*BI(1)*(1.D0+B*(T-U)/S4))
     2        -2.D0*(S*S4*CI(1)*(1.D0-B*S*(T-U)/S4/S4)
     3        +S*(S4*(1.D0+B*(T-U)/S4)+2.D0*S2)*CI(4)
     4        +2.D0*(U1**2*T1*(1.D0+B*S/S4)
     5              +EMZ2*S*(2.D0*U1+EMZ2)*(1.D0+B*(T-U)/S4)
     6              +2.D0*U1**2*(S-EMZ2))/U1*CI(3)
     7        +2.D0*(T1**2*U1*(1.D0-B*S/S4)
     8              +EMZ2*S*(2.D0*T1+EMZ2)*(1.D0+B*(T-U)/S4)
     9              +2.D0*T1**2*(S-EMZ2))/T1*CI(2))
     1  +2.D0*EQ2/EMZ2*(S**2*CI(1)*(1.D0-B*(T-U)/S)
     2   +(S*(U+EMZ2)**2*(1.D0-B*(T-U)/S4)+4.D0*EMZ2*U1**2)/U1*CI(3)
     3   +(S*(T+EMZ2)**2*(1.D0-B*(T-U)/S4)+4.D0*EMZ2*T1**2)/T1*CI(2))
     4  -2.D0*S*(U*(U1*(1.D0-B*S/S4)+2.D0*EMZ2)*DI(2)
     5          +T*(T1*(1.D0+B*S/S4)+2.D0*EMZ2)*DI(1))
     6  +EQ2/EMZ2*(S4*Y*DI(3)*(1.D0-B*S*(T-U)/S4/S4)
     7    +(8.D0*EMZ2*U1*(U+EMZ2)*(1.D0+B*S/S4)
     8    -S**2*U*(1.D0-B*(T-U)/S4)+4.D0*EMZ2*(U*S4+4*EMZ2**2))*DI(2)
     9    +(8.D0*EMZ2*T1*(T+EMZ2)*(1.D0-B*S/S4)
     1    -S**2*T*(1.D0-B*(T-U)/S4)+4.D0*EMZ2*(T*S4+4*EMZ2**2))*DI(1)))
     2   +A2MB2*FAC*EQ2/EMZ2*(1.D0-B*(T-U)/S4)*
     3  (-2.D0*S*CI(1)-2.D0*U1*CI(3)-2.D0*T1*CI(2)
     4  -(S+4.D0*EMZ2)/S4*Y*DI(3)+U*S*DI(2)+T*S*DI(1))
      RETURN
      END
