*----------------------------------------------------------------------------*
      FUNCTION APMPP(S,T,U,EMZ2,EQ2,B,A2PB2,A2MB2)
      IMPLICIT REAL*8(A-H,O-Z)
      double complex APMPP
      COMPLEX*16 BI(4),CI(4),DI(3)
      COMMON/CINTS/BI,CI,DI
      Y=U*T-EMZ2**2
      S4=S-4.D0*EMZ2
      S2=S-2.D0*EMZ2
      T1=T-EMZ2
      U1=U-EMZ2
      APMPP=A2PB2*
     1 (-8.D0*S2*Y/S4/U1/T1
     2  +8.D0*EMZ2/S4*(BI(2)*(2.D0*EMZ2*T+Y)/T1**2
     3                 +BI(3)*(2.D0*EMZ2*U+Y)/U1**2)
     4  -8.D0*EMZ2/S4*(S*CI(1)+S2*CI(4)
     5                -(S2*T-T1**2)/T1*CI(2)
     6                -(S2*U-U1**2)/U1*CI(3))
     7  +16.D0*S2*EQ2*Y/S/S4*(CI(2)/T1+CI(3)/U1)
     8  +4.D0*S*EMZ2/S4*(U*DI(2)+T*DI(1))
     9  +8.D0*EMZ2*EQ2/S/S4*(S*S2*(DI(2)+DI(1))
     1                      +(S*S4-2*Y)*DI(3))
     2  +4.D0*S*S2*EMZ2/S4/Y*(S2*CI(1)+S4*CI(4)
     3                       +2*U**2/U1*CI(3)+2*T**2/T1*CI(2)
     4                       +T**2*DI(1)+U**2*DI(2)))
     5   +A2MB2*
     6  (16.D0*EQ2*(T*CI(2)/T1+U*CI(3)/U1-CI(4))
     7   +8.D0*EQ2*Y/S4*DI(3)
     8   +16.D0*EQ2**2*(DI(3)+DI(2)+DI(1))
     9   +8.D0*EQ2*S/Y*(S2*CI(1)+S4*CI(4)
     1                 +2.D0*U**2/U1*CI(3)+2.D0*T**2/T1*CI(2)
     2                 +T**2*DI(1)+U**2*DI(2)))
      RETURN
      END
