
*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  22.06.2004                                  *
*   color flow and showering description for PYTHIA                          *
*  Z Q Qbar production (SM)                                                  *
*   TopReX code = 23                                                         *
      subroutine COLORF_23(ip1, ip2)
*     -------------------------------                                        *
      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
*..................TopReX commons and internal variables
      Integer ip1, ip2 
      integer ik1,ik3 
      common /kfzqq/ik1, ik3 
      double precision zn1, zn2
      COMMON /colden/ zn1, zn2
*...END VARIABLE'S DEFINITION
*............................................................................*
* PYUPR :        1   2        3       4  5    6  7
*      nup = 7 ! q   q~ -> Z(gamma*)  f  f~   Q  Qbar
* how PYTHIA will be treated
        istup(3) = 2  ! final Z(gamma*) 
        istup(4) = 1  ! final f
        istup(5) = 1  ! final fbar
        istup(6) = 1  ! final Q
        istup(7) = 1  ! final Qbar
* parent's lines 
          mothup(1,3)=1  
          mothup(2,3)=2  
            mothup(1,4)=3 
            mothup(2,4)=3 
            mothup(1,5)=3 
            mothup(2,5)=3 
          mothup(1,6)=1  
          mothup(2,6)=2  
          mothup(1,7)=1  
          mothup(2,7)=2  
* KF code
      if(Ipar(23).eq.0.OR.Ipar(23).eq.2) then
        idup(3) = 23  ! Z
      elseif(Ipar(23).eq.1) then
        idup(3) = 22  ! gamma*
      endif  
      idup(4) =  ik1
      idup(5) = -ik1
      idup(6) =  ik3
      idup(7) = -ik3
*
      idup(1) = ip1 
       if(idup(1).eq.0) idup(1) = 21
      idup(2) = ip2
       if(idup(2).eq.0) idup(2) = 21
       
*  color flow 
       ipar(50) = 300
       icolup(1,6) = ipar(50) + 1
       icolup(2,7) = ipar(50) + 2

        if(idup(1).eq.21) then         ! gluon gluon
         if(abs(zn1).le.abs(zn2)) then  ! t-channel
* color flow :   t-channel
*       color(g1) -> T[3]   anti-color(g1) -> g2
*       color(g2) -> g1     anti-color(g2) -> T~[4]
          icolup(1,1) = icolup(1,6)  
          icolup(2,1) = ipar(50) + 3 
          icolup(1,2) = icolup(2,1)  
          icolup(2,2) = icolup(2,7)
          else
* color flow : u-channel
*       color(g1) -> g2   anti-color(g1) -> T~[4]
*       color(g2) -> T[3] anti-color(g2) -> g1
          icolup(1,1) = ipar(50) + 3 
          icolup(2,1) = icolup(2,7) 
          icolup(1,2) = icolup(1,6)  
          icolup(2,2) = icolup(1,1)
         endif  ! finish gluon gluon color prescription 
        elseif(ip1.gt.0) then  ! quark
          icolup(1,1) = icolup(1,6)          
          icolup(2,2) = icolup(2,7)          
        elseif(ip1.lt.0) then
          icolup(2,1) = icolup(2,7)          
          icolup(1,2) = icolup(1,6)          
        endif
      if(abs(ik1).le.6) then
       icolup(1,4) = ipar(50) + 4
       icolup(2,5) = ipar(50) + 4
      endif

      return
      end
