*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  09.09.2002                                  *
*   color flow and showering description for PYTHIA                          *
*   t tbar  production (SM)                                                  *
*   TopReX code = 20                                                         *
      subroutine COLORF_25(ip1, ip2)
*     -------------------------------                                        *
      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
*..................TopReX commons and internal variables
      Integer I, ip1, ip2,  ntop, kpp(2), kftop(2) 
      double precision zn1, zn2
      COMMON /colden/ zn1, zn2
      double precision vh 
      common /topol2/  vh(2,3,3)
      double precision vtt3
      common /topol2gam/ vtt3(3,3,3)
      integer j1, j2
*...END VARIABLE'S DEFINITION

*............................................................................*
*     q([1] ---------O=======> top     [3]                                   *
*                    <                                                       *
*                    >                                                       *
*                    <                                                       *
*     q_[2] ---------O=======> top_bar [4]                                   *
*............................................................................*

* PYUPR :        1   2     3   4  
*
*      nup = 4 ! q   q~ -> t   t~ gamma 
* how PYTHIA will be treated
        istup(3) = 2  ! final top 
        istup(4) = 2  ! final topbar
        istup(5) = 1  ! final photon
* parent's lines 
          mothup(1,3)=1  
          mothup(2,3)=2  
            mothup(1,4)=1 
            mothup(2,4)=2 
             mothup(1,5)=1 
             mothup(2,5)=2 
* KF code
      idup(3) =  6
      idup(4) = -6
      idup(5) = 22 ! photon
*
      idup(1) = ip1 
       if(idup(1).eq.0) idup(1) = 21
      idup(2) = ip2
       if(idup(2).eq.0) idup(2) = 21
*  color flow 
       ipar(50) = 300
       icolup(1,3) = ipar(50) + 1
       icolup(2,4) = ipar(50) + 2

        if(idup(1).eq.21) then         ! gluon gluon
         if(abs(zn1).ge.abs(zn2)) then  ! t-channel
* color flow :   t-channel
*       color(g1) -> T[3]   anti-color(g1) -> g2
*       color(g2) -> g1     anti-color(g2) -> T~[4]
          icolup(1,1) = icolup(1,3)  
          icolup(2,1) = ipar(50) + 3 
          icolup(1,2) = icolup(2,1)  
          icolup(2,2) = icolup(2,4)
          else
* color flow : u-channel
*       color(g1) -> g2   anti-color(g1) -> T~[4]
*       color(g2) -> T[3] anti-color(g2) -> g1
          icolup(1,1) = ipar(50) + 3 
          icolup(2,1) = icolup(2,4) 
          icolup(1,2) = icolup(1,3)  
          icolup(2,2) = icolup(1,1)
         endif  ! finish gluon gluon color prescription 
        elseif(ip1.gt.0) then  ! quark
          icolup(1,1) = icolup(1,3)          
          icolup(2,2) = icolup(2,4)          
        elseif(ip1.lt.0) then
          icolup(2,1) = icolup(2,4)          
          icolup(1,2) = icolup(1,3)          
        endif
* top decays 
       do j1 = 1,3
        do j2 = 1,3
         vh(1, j1, j2) = vtt3(1, j1, j2) 
        if(abs(ip1).eq.1.OR.abs(ip1).eq.3.OR.
     &                       abs(ip1).eq.5) then
         vh(2, j1, j2) = vtt3(3, j1, j2) 
        elseif(abs(ip1).eq.2.OR.abs(ip1).eq.4) then
         vh(2, j1, j2) = vtt3(2, j1, j2) 
        endif
        enddo
       enddo
      ntop = 0
      do I = 3, Nup
       if(abs(idup(I)).eq.6) then
         ntop = ntop + 1
         kpp(ntop) = I
         kftop(ntop) = idup(i)
       endif
      enddo
       if(ntop.ge.1) then
        call top_decay(ntop, kpp, kftop) 
       endif

      return
      end
