*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  01.03.2004                                  *
*   FCNC top production : 2 -> 1  including SM contribution  gu(c)->bW       *
*   TopReX code = 12                                                         *
*   color flow and showering description for PYTHIA                          *
      subroutine COLORF_29(ip1, ip2)
*     ------------------------------                                         *
*............................................................................*
      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      integer ip1, ip2, KT, KW, Ires, IR, kff1, kff2
*      integer I
*.................  FCNC :   2 -> 1 .........................................*
*     g(U)[1] \            /   b[3]                                          *
*              \          /                                                  *
*               == T[.]==/                                                   *
*              /         >                                                   * 
*     U(g)[2] /           <                                                  *
*..........................>  W[4] -> L+-[5] NU[6] ..........................*

* HEPEUP :        1     2       3     4 
*       nup = 6 ! 
* how PYTHIA will be treated
        istup(3) =  1 ! final b
        istup(4) =  2 ! final W+-
        istup(5) =  1 ! final NU  (or Dbar)
        istup(6) =  1 ! final L+- (or U)
* parent's lines
        mothup(1,3)=1  ! final b
        mothup(2,3)=2  
         mothup(1,4)=1  ! final W
         mothup(2,4)=2  !
          mothup(1,5)=4  ! final L+- (U)
          mothup(2,5)=4  !
           mothup(1,6)=4  ! final NU  (Dbar)
           mothup(2,6)=4  !
* KF code
        if(idup(1).eq.0) idup(1) = 21
        if(idup(2).eq.0) idup(2) = 21
         KT = +1   ! top
         if(ip1.lt.0.OR.ip2.lt.0) KT = -1 ! antitop
        idup(3) = KT*5
        idup(4) = KT*24
        KW = idup(4)
* colors flow
        ipar(50) = 300
      if(ip1.eq.0)  then   !  GLUON Q      
       icolup(1,1) = ipar(50)      ! color
       icolup(2,1) = ipar(50) + 1  ! anticolor
         if(kt.eq.1) then
          icolup(1,2) = ipar(50) + 1
          icolup(2,2) = 0
          icolup(1,3) = ipar(50)
          icolup(2,3) = 0
         else
          icolup(1,2) = 0
          icolup(2,2) = ipar(50)
          icolup(1,3) = 0
          icolup(2,3) = ipar(50) + 1
         endif
      elseif(ip2.eq.0)  then   !  GLUON Q      
       icolup(1,2) = ipar(50)      ! color
       icolup(2,2) = ipar(50) + 1  ! anticolor
        if(kt.eq.1) then
         icolup(1,1) = ipar(50) + 1
         icolup(2,1) = 0
         icolup(1,3) = ipar(50)
         icolup(2,3) = 0
        else
         icolup(1,1) = 0
         icolup(2,1) = ipar(50)
         icolup(1,3) = 0
         icolup(2,3) = ipar(50) + 1
        endif
       endif
*  fill information about fermions from W
      Ires = 2  ! W-boson
      call Res_branch(2, kw, Ir)
      kw = kw / abs(kw)         ! +1(-1) for W+(W-)
      kff1 = kw * FID(Ires,Ir,1)   ! KF code of first  fermion 
      kff2 = kw * FID(Ires,Ir,2)   ! KF code of second fermion 
      call colorf_bff(4, 5, kff1,  6, kff2) 

      return
      end
