

c----------------------------------------------------------------------------c
*.. author:  Serge Slabospitsky  06.06.2006                                  *
* FCNC : G G -> T q                                                          *
*   TopReX code = 32                                                         *
      subroutine COLORF_32(ip1, ip2)
*     ------------------------------                                         *
*............................................................................*
      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      integer I, ip1, ip2, ntop, kpp(2), kftop(2), 
     & icl1, icl2, icl3 
      integer           kft, kfq, idia
      common /tplFC_GG/ kft, kfq, idia
*....... FCNC g g -> t q ....................................................*
*     q   [1] ---------O----------  q[3]                                     *
*                      <                                                     *
*                      <                                                     * 
*     q   [2] ---------O==========  T [4]                                    *
*............................................................................*
* HEPEUP :        1     2       3     4 
*       nup = 4 
* how PYTHIA will be treated
        istup(4) =  2 ! final top 
        istup(3) =  1 ! final q
*
      idup(1) = ip1 
       if(idup(1).eq.0) idup(1) = 21
      idup(2) = ip2
       if(idup(2).eq.0) idup(2) = 21
* parent's lines
          mothup(1,3)=1  ! final q
          mothup(2,3)=2  !
           mothup(1,4)=1  ! final top
           mothup(2,4)=2  !
*
          idup(3) = kfq
          idup(4) = kft
*  color flow 
       ipar(50) = 301
       icl1 = 301
       icl2 = 302
       icl3 = 303
* 
      IF(kft.eq.+6) then ! Top
       if(idia.eq.1) then ! t-channel
          icolup(1,1) = icl1 !  color first  gluon
          icolup(2,1) = icl2 ! Acolor first  gluon
          icolup(1,2) = icl2 !  color second gluon
          icolup(2,2) = icl3 ! Acolor second gluon

          icolup(1,3) = 0
          icolup(2,3) = icl3 ! Acol from second gluon
          icolup(1,4) = icl1 ! col  from first  gluon
          icolup(2,4) = 0
       elseif(idia.eq.2) then ! u-channel
          icolup(1,1) = icl1 !  color first  gluon
          icolup(2,1) = icl2 ! Acolor first  gluon
          icolup(1,2) = icl3 !  color second gluon
          icolup(2,2) = icl1 ! Acolor second gluon

          icolup(1,3) = 0
          icolup(2,3) = icl2 ! Acol from first  gluon
          icolup(1,4) = icl3 ! col  from second gluon
          icolup(2,4) = 0
       endif 
      ELSEIF(kft.eq.-6) then ! Tbar
       if(idia.eq.1) then ! t-channel
          icolup(1,1) = icl1 !  color first  gluon
          icolup(2,1) = icl2 ! Acolor first  gluon
          icolup(1,2) = icl3 !  color second gluon
          icolup(2,2) = icl1 ! Acolor second gluon

          icolup(1,3) = icl3 ! col  from second gluon
          icolup(2,3) = 0
          icolup(1,4) = 0
          icolup(2,4) = icl2 ! Acol  from first  gluon

       elseif(idia.eq.2) then ! u-channel
          icolup(1,1) = icl1 !  color first  gluon
          icolup(2,1) = icl2 ! Acolor first  gluon
          icolup(1,2) = icl2 !  color second gluon
          icolup(2,2) = icl3 ! Acolor second gluon

          icolup(1,3) = icl1 !  col from first  gluon
          icolup(2,3) = 0
          icolup(1,4) = 0
          icolup(2,4) = icl3 ! Acol  from second gluon
       endif 
      ENDIF
**
*      print*,'**********************'
*      do I = 1, Nup
*       print*,'I ',I,' is KF',idup(i),' MOT ',
*     & mothup(1,i),mothup(2,i),' COL ',icolup(1,I),icolup(2,i)
*      enddo
 
      ntop = 0
      do I = 3, Nup
       if(abs(idup(I)).eq.6) then
        ntop = ntop + 1
        kpp(ntop) = I
        kftop(ntop) = idup(i)
       endif 
      enddo
       if(ntop.ge.1) then
        call top_decay(ntop, kpp, kftop) 
       else 
        print*,' NO top is found. Stop run'
        STOP ! no top quark
       endif
      return
      end
