*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  24/06/2000                                  *
*----------------------------------------------------------------------------*
*... Author  :  Serge Slabospitsky                                           *
*... 25/04/2000                                                              *
*... return cos(theta*), where theta* is the angle between b-momentum        *
*..  direction of first p-momentum in P rest frame                           *
*............................................................................*

*
      Subroutine costhet_s (P, B, cost)

      Implicit None
      double precision P(5), B(5), cost, v(5)
      double precision scalp, mt, eb, pb, pp
      Integer I
*
      mt = sqrt( scalp(p, p) )
      Eb = scalp(p, b) / mt
      pb = sqrt(Eb*Eb - scalp(b,b))
      pp = sqrt(p(1)**2 + p(2)**2 + p(3)**2)
       do i = 1,3
        v(i) = (p(4)/mt) * p(i) / pp
       enddo
       v(4) = pp / mt
      cost = -scalp(v,b) / pb
      return
      end
