c----------------------------------------------------------------------------c
*.. author:  Serge Slabospitsky    06.09.2002                                * 
      subroutine DECHEP(KI, KD, KO) 
*     -----------------------------------------------                        *
*  special case !
*  KI is position in HEPEUP list of P, which define Lorentz boost            *
*  KD is position in decmom list of particle in KI rest frame                * 
*  KO is position in HEPEUP list of boosted P-particle                       *
*............................................................................*
      implicit none
*
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      integer mxdc
      parameter (mxdc=20)   
      integer ndec, kdec
      double precision pdm, pdpl
      common /decmom/ pdm(mxdc,5), pdpl(mxdc,4), ndec, kdec(mxdc,3)
      integer ki, ko, kd 
      double precision pf4, fn
*.....
      if (pup(4,KI).eq.pup(5,KI)) go to 17
      pf4  = ( pdm(KD,4)*pup(4,KI) + pdm(KD,3)*pup(3,KI)
     &       + pdm(KD,2)*pup(2,KI) + pdm(KD,1)*pup(1,KI))
     &          / pup(5,KI)
      fn   = (pf4+pdm(KD,4)) / (pup(4,KI)+pup(5,KI))
      pup(1,KO)= pdm(KD,1) + fn*pup(1,KI)
      pup(2,KO)= pdm(KD,2) + fn*pup(2,KI)
      pup(3,KO)= pdm(KD,3) + fn*pup(3,KI)
      pup(4,KO)= pf4
      go to 18
c
   17 pup(1,KO) = pdm(KD,1)
      pup(2,KO) = pdm(KD,2)
      pup(3,KO) = pdm(KD,3)
      pup(4,KO) = pdm(KD,4)
c
   18 pup(5,KO) = pdm(KD,5)
      RETURN
      END
