*----------------------------------------------------------------------------*
*.. author : Serge Slabospitsky   02.05.2006                                 *
*....                                                                        *
      subroutine EPSIL3(B, C, D, EPS)
*     ------------------------------                                         *
*                                                                            *
* EPS(nu) = epsilon(nu, bl, cl, dl)  B(bl) C(cl) D(dl) is 5-vector           *
* B, C, D,  are 5-vectors                                                    *
*............................................................................*
      implicit None
      double precision EPS(5), B(5), C(5), D(5) 
*
      eps(4) = - B(1) * (C(2)*D(3) - C(3)*D(2))
     &         + B(2) * (C(1)*D(3) - C(3)*D(1))
     &         - B(3) * (C(1)*D(2) - C(2)*D(1))
      eps(1) = - B(4) * (C(2)*D(3) - C(3)*D(2))
     &         + B(2) * (C(4)*D(3) - C(3)*D(4))
     &         - B(3) * (C(4)*D(2) - C(2)*D(4))
      eps(2) =   B(4) * (C(1)*D(3) - C(3)*D(1))
     &         - B(1) * (C(4)*D(3) - C(3)*D(4))
     &         + B(3) * (C(4)*D(1) - C(1)*D(4))
      eps(3) = - B(4) * (C(1)*D(2) - C(2)*D(1))
     &         + B(1) * (C(4)*D(2) - C(2)*D(4))
     &         - B(2) * (C(4)*D(1) - C(1)*D(4))
      return
      end
