


*----------------------------------------------------------------------------*
*.. author : Serge Slabospitsky   02.05.2006                                 *
*....                                                                        *
      subroutine EPSIL4(A, B, C, D, EPS4)
*     ------------------------------                                         *
*                                                                            *
* EPS4 = epsilon(al, bl, cl, dl) A(al) B(bl) C(cl) D(dl)                     *
* A, B, C, D are 5-vectors                                                   *
*............................................................................*
      implicit None
      double precision A(5), B(5), C(5), D(5), EPS4, V(4)
 
*
      V(4) = - B(1) * (C(2)*D(3) - C(3)*D(2))
     &       + B(2) * (C(1)*D(3) - C(3)*D(1))
     &       - B(3) * (C(1)*D(2) - C(2)*D(1))
      V(1) = - B(4) * (C(2)*D(3) - C(3)*D(2))
     &       + B(2) * (C(4)*D(3) - C(3)*D(4))
     &       - B(3) * (C(4)*D(2) - C(2)*D(4))
      V(2) =   B(4) * (C(1)*D(3) - C(3)*D(1))
     &       - B(1) * (C(4)*D(3) - C(3)*D(4))
     &       + B(3) * (C(4)*D(1) - C(1)*D(4))
      V(3) = - B(4) * (C(1)*D(2) - C(2)*D(1))
     &       + B(1) * (C(4)*D(2) - C(2)*D(4))
     &       - B(2) * (C(4)*D(1) - C(1)*D(4))
      EPS4  = A(4)*V(4) - A(1)*V(1) - A(2)*V(2) - A(3)*V(3)
      return
      end
