*----------------------------------------------------------------------------*
*.. author : Serge Slabospitsky   21/11/2000                                 *
*....                                                                        *
      double precision FUNCTION ETARAP(P)
*     -----------------------------------                                    *
*...pseudorapidity(ETA)  CALCULATION                                         *
*............................................................................* 
      IMPLICIT NONE

      double precision P(5), COST
 
       COST = P(3) / DSQRT(P(1)**2 + P(2)**2 + P(3)**2)
       IF(dABS(COST).LT.0.999999) THEN
          ETARAP = 0.5 * dLOG((1.+ COST)/(1.- COST))
        ELSE
          ETARAP = 10000.
       ENDIF
      return 
      END
