*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  26.01.2002                                  *
*............................................................................*
      subroutine gejzer_23(NFP) 
      Implicit None
      include "txpar.inc"  
      integer NFP          ! number of particles in hard process 
      double precision           sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      integer I, J, ik1,ik3 
      common /kfzqq/ik1, ik3 
      double precision coef
*.......
      double precision sigZqq, effzqq(0:16), coeffZqq(16), ARAN, PYR
      integer jproc
      save effZqq, coeffZqq
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
      double precision eqf(2,-20:20), zff(2,-20:20)
      common /Vboscpl/ eqf, zff
*..
      IF(first) THEN
         do j = 0,16
          effzqq(j) = 0.d0
         enddo
       I = -1 
        do J = 1,15
         if(mid(j,4).ge.1) I = +1
        enddo
        if(I.eq.-1) then
         print*,' ZQQ: no open Z-boson decay channels. stop'
         STOP
        endif
        first=.FALSE.
***
         sigZqq = 0.d0
       do j = 1,16
        coeffZqq(j) = 0.d0
         if(mid(j,4).ge.1) then
           ik1 = fid(4,j,1)
          coeffZqq(j) = zff(1,ik1)**2 + zff(2,ik1)**2
           if(Ipar(23).eq.1)  coeffZqq(j) = eqf(2,ik1)**2          
         endif
         if(j.le.6) coeffZqq(j) = coeffZqq(j) * 3.d0
         sigZqq =  sigZqq + coeffZqq(j)
       enddo
*..Ipar(23)     : Zqq, 0: gam* + Z,   1: gam*, 2: Z                          *

        effZqq(0) = 0.d0
       do j = 1,16
         if(mid(j,4).ge.1) then
             coeffZqq(j) = coeffZqq(j) / sigZqq
             effZqq(j)   = effZqq(0) + coeffZqq(j) 
             effZqq(0)   = effZqq(j)
         endif
       enddo
      ENDIF
 
*..........................................
 502  continue  ! normal running
      ARAN = pyr(0) 
       do j = 1,16
         if(mid(j,4).ge.1) then
           if(aran.le.effZqq(j)) then
             jproc = j
             goto 503
           endif
         endif
       enddo
 503   continue

      ik1 = fid(4,jproc,1)
      ik3 = Ipar(7) !  5

      coef = 1.d0 / coeffZqq(jproc)
      call gejzer_zqq(coef) 

      sigrx = 0.d0
      do i = -5,5
        do j=-5,5
          sigrx = sigrx + xcs(i,j)
        enddo
      enddo
      NFP = 7
*       call examhard6(sigrx)
      return
      end
