*----------------------------------------------------------------------------*
*... Authors  : Serge Slabospitsky                                           *
* direct top production due to FCNC  2 -> 1                                  *
*............................................................................*

      subroutine gejzer_29(NFP)
      implicit None
      include "txpar.inc" 
      Integer NFP          ! number of particles in hard process 
      double precision Pus
      common /user_mom/Pus(20,5)
      double precision  pn(5), PL(5)
      double precision  q1(5), q2(5), qq(5) 
      double precision            sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      Integer I,  L, iq, j8,j9 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision  x1, x2, sg, sgs

      double precision  ves
      dimension ves(-6:6,-6:6)
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision pdfbt(-5:5, -5:5)
      double precision veslum, ves1, sqhat_min, sqhat_max, parl(3) 
      save   sqhat_max, sqhat_min 
*
      double precision PARR(4), PT, wr(2), pb(5), vesGU, vesUG
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
*      integer        PID(20) 
*      common /TXtopcpl/ PID      ! 1/0 = ON/OFF top interaction 
*      save   /TXtopcpl/
      integer imatch
      common /wmtch/imatch 
*..............
      if(first) THEN
      first=.FALSE.
        if(mid(11,1).eq.0.AND.mid(12,1).eq.0.and.Ipar(26).eq.2) then 
         print*,' '
         print*,'TopReX  FCNC process  ',ipar(1)
         print*,' FCNC (top -> !UP+CHARM! gluon) is switched OFF'
         print*,' stop TopReX run '
          STOP 
         return
        endif 
*..RPAR(101)    : sqrt(Shat_MIN) for hard process                          
*..RPAR(102)    : sqrt(Shat_MAX) for hard process                            
       imatch = 1  ! for TopReX matching
       sqhat_min = rpar(101)
       sqhat_max = rpar(102)
      write(*,7051) sqhat_min, sqhat_max 
 7051 format(/,' sqrt(Shat) from ',f8.2,' to ',f8.2)
         if(sqhat_min.ge.sqhat_max) then
          write(*,7053) 
 7053    format(/,' Shat_min greater than Shat_max  stop running')
          STOP 
         endif
*
       imatch = 1  ! for TopReX matching

        ParR(1) = Rpar(41) 
        ParR(2) = Rpar(44) 
        ParR(3) = sqhat_min
        ParR(4) = sqhat_max
         pn(5) = 0.d0 
         PL(5) = 0.d0
      ENDIF
      
       imatch = 1  ! for TopReX matching
      do j8 = -6,6
      do j9 = -6,6
       XCS(j8,j9) = 0.d0
      enddo
      enddo
      call zer5mom(q1) 
      call zer5mom(q2) 
      
        q1(5) = 0.d0
        q2(5) = 0.d0

        pb(5) = mq(5)
       parL(1) = rpar(103) + dsqrt(sqhat_min**2+rpar(103)**2) 
       ParL(2) = rpar(102)      ! M(W*)_max for production
       parL(3) = Rpar(1)
       WR(1) = mq(6) 
       WR(2) = Rpar(36)   ! M(W) * Width(W) 


 100   continue
      if(Ipar(26).eq.2) then 
         call X1X2RES( ParL, WR, X1, X2, Veslum, q1, q2, QQ)
      else
       call X1X2GEN(parl, X1, X2, Veslum, q1, q2, QQ)
      endif
**
       q1(4) = dabs(q1(3))
       q2(4) = dabs(q2(3))
      call mass2(q1, q2, sg, sgs)

      Rpar(5) = mq(6) ! PH(5)   ! mass(H* or W*) ==> Q-scale for PDF
      call TXQscale  ! setting Q-scale for PDF( Rpar(3)) and for alpha_s    
      call pdf_BT(x1, x2, pdfbt)

      pb(5) = mq(5)
      pl(5) = 0.d0
      pn(5) = 0.d0
      call LIPS_Res_Wff(QQ, pb, pl, pn, Ves1)
      if(pt(pb).lt.rpar(103)) goto 100

      veslum = veslum * ves1 * pi2_4 / (2.*sg)
      do j8 = -6,6
      do j9 = -6,6
       VES(j8,j9) = 0.d0
      enddo
      enddo
      do i = 1,5
        pus(1,i) = q1(i)
        pus(2,i) = q2(i)
        pus(3,i) = pb(i) 
      enddo  
*

      iq = 2 ! up
      call tfcnc_SM(iq, q1, q2, pb, pl, pn, vesGU)
      call tfcnc_SM(iq, q2, q1, pb, pl, pn, vesUG)
      Xcs( 0, iq)=Veslum*vesGU*pdfBT( 0, iq)*BRS(1,2) ! BRS is W branching
      Xcs( 0,-iq)=Veslum*vesGU*pdfBT( 0,-iq)*BRS(2,2) 
      Xcs( iq, 0)=Veslum*vesUG*pdfBT( iq, 0)*BRS(1,2) 
      Xcs(-iq, 0)=Veslum*vesUG*pdfBT(-iq, 0)*BRS(2,2) 

      iq = 4 ! up
      call tfcnc_SM(iq, q1, q2, pb, pl, pn, vesGU)
      call tfcnc_SM(iq, q2, q1, pb, pl, pn, vesUG)
      Xcs( 0, iq)=Veslum*vesGU*pdfBT( 0, iq)*BRS(1,2) ! BRS is W branching
      Xcs( 0,-iq)=Veslum*vesGU*pdfBT( 0,-iq)*BRS(2,2) 
      Xcs( iq, 0)=Veslum*vesUG*pdfBT( iq, 0)*BRS(1,2) 
      Xcs(-iq, 0)=Veslum*vesUG*pdfBT(-iq, 0)*BRS(2,2) 


      sigrx=0.d0
      do i= -5 ,5
        do l= -5, 5 
          sigrx = sigrx + xcs(i,l)
        enddo
      enddo

 444  continue
       nfp = 6 ! 7 was in previous version 03.05.2006
       do i = 1, 5
        pus(1,i) = q1(i)
        pus(2,i) = q2(i)
*        pus(3,i) = QQ(i)        !  top 
        pus(3,i) = pb(i)         !  b-quark
        pus(4,i) = pl(i) + pn(i) !  W-quark
        pus(5,i) = pn(i)         !  nu  !  NEUTRINO is the first
        pus(6,i) = pl(i)         !  L+-
       enddo
        pus(4,5) = dsqrt(pus(4,4)**2-pus(4,1)**2
     &                 - pus(4,2)**2-pus(4,3)**2)
      return
      end
