*----------------------------------------------------------------------------*
*... Authors  : Serge Slabospitsky                                           *
* direct top production due to FCNC  2 -> 1                                  *
*............................................................................*
      subroutine gejzer_30(NFP)
      implicit None
      include "txpar.inc" 
      Integer NFP          ! number of particles in hard process 
      double precision Pus
      common /user_mom/Pus(20,5)
      double precision  q1(5), q2(5), ptop(5) 
      double precision            sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      Integer I,  L, iq, j8,j9 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision  x1, x2
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision pdfbt(-5:5, -5:5)
      double precision veslum, sqhat_min, sqhat_max, parl(3) 
      save   sqhat_max, sqhat_min 
*
      double precision wr(2), vesGU, vesUG
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
      integer imatch
      common /wmtch/imatch 
      double precision hrgu   ,hrug   , hrgc   , hrcg   
      common /fcncpol/ hrgu(4),hrug(4), hrgc(4), hrcg(4)
*..............
      if(first) THEN
      first=.FALSE.
        if(mid(11,1).eq.-1.AND.mid(12,1).eq.-1) then 
         print*,' '
         print*,'TopReX  FCNC process  ',ipar(1)
         print*,' FCNC (top -> !UP+CHARM! gluon) is switched OFF'
         print*,' stop TopReX run '
         stop ! STOP
         return
        endif 
*
*..RPAR(101)    : sqrt(Shat_MIN) for hard process                          
*..RPAR(102)    : sqrt(Shat_MAX) for hard process                            
       sqhat_min = mq(6) - 25.d0*rpar(34)
       sqhat_max = mq(6) + 25.d0*rpar(34)
      if(abs(sqhat_min-mq(6)).ge.60.d0) sqhat_min = mq(6) - 60.d0
      if(abs(sqhat_max-mq(6)).ge.60.d0) sqhat_max = mq(6) + 60.d0

      write(*,7051) sqhat_min, sqhat_max 
 7051 format(/,' sqrt(Shat) from ',f8.2,' to ',f8.2)
         if(sqhat_min.ge.sqhat_max) then
          write(*,7053) 
 7053    format(/,' Shat_min greater than Shat_max  stop running')
          STOP 
         endif
      

       parL(1) = sqhat_min 
       ParL(2) = sqhat_max
       parL(3) = Rpar(1)
       WR(1) = mq(6) 
       WR(2) = Rpar(36)   ! M(W) * Width(W) 
      ENDIF
      
      imatch = 1  ! for TopReX matching
      do j8 = -6,6
      do j9 = -6,6
       XCS(j8,j9) = 0.d0
      enddo
      enddo
      call zer5mom(q1) 
      call zer5mom(q2) 

        q1(5) = 0.d0
        q2(5) = 0.d0
         call X1X2delf( ParL, WR, X1, X2, Veslum, q1, q2, ptop)
**
      Rpar(5) = mq(6) ! PH(5)   ! mass(H* or W*) ==> Q-scale for PDF
      call TXQscale  ! setting Q-scale for PDF( Rpar(3)) and for alpha_s    
      call pdf_BT(x1, x2, pdfbt)

      veslum = veslum * pi / ptop(5)**2
*
      iq = 2 ! up
      call tfcnc_00(iq, q1, ptop, vesGU, hrGU)
      call tfcnc_00(iq, q2, ptop, vesUG, hrUG)
      Xcs( 0, iq)=Veslum*vesGU*pdfBT( 0, iq)*BRS(1,2) ! BRS is W branching
      Xcs( 0,-iq)=Veslum*vesGU*pdfBT( 0,-iq)*BRS(2,2) 
      Xcs( iq, 0)=Veslum*vesUG*pdfBT( iq, 0)*BRS(1,2) 
      Xcs(-iq, 0)=Veslum*vesUG*pdfBT(-iq, 0)*BRS(2,2) 

      iq = 4 ! up
      call tfcnc_00(iq, q1, ptop, vesGU, hrGC)
      call tfcnc_00(iq, q2, ptop, vesUG, hrCG)
      Xcs( 0, iq)=Veslum*vesGU*pdfBT( 0, iq)*BRS(1,2) ! BRS is W branching
      Xcs( 0,-iq)=Veslum*vesGU*pdfBT( 0,-iq)*BRS(2,2) 
      Xcs( iq, 0)=Veslum*vesUG*pdfBT( iq, 0)*BRS(1,2) 
      Xcs(-iq, 0)=Veslum*vesUG*pdfBT(-iq, 0)*BRS(2,2) 


      sigrx=0.d0
      do i= -5 ,5
        do l= -5, 5 
          sigrx = sigrx + xcs(i,l)
        enddo
      enddo

 444  continue
       nfp = 3 
       do i = 1, 5
        pus(1,i) = q1(i)
        pus(2,i) = q2(i)
        pus(3,i) = ptop(i)          !  top 
       enddo
      return
      end
