*----------------------------------------------------------------------------*
      subroutine GGZZ(p1, p2, p3, p4, vesm)
      implicit none
      include "txpar.inc" 
      double precision p1(5), p2(5), p3(5), p4(5) 
      double precision Vesm 
      double precision s,t,u,s2,s4,yr
      common /varz0/s,t,u,s2,s4,yr
      double precision gv2, ga2 
      common /gvga/    gv2, ga2 
      double precision mqq2, mqq4, mqq6
      common /masqz/   mqq2, mqq4, mqq6
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision mz2, mz4
      common /masszbos/ mz2, mz4
      double precision bet
      common /zzbet/ bet
      save /zzbet/ 
      integer I
      integer izmod, IQ
      common /izzmod/izmod, IQ
      save /izzmod/
      double complex EPS
      COMMON/SMALL/EPS
      data EPS/(0.0D0,-1.0D-8)/
      save /SMALL/
      integer NQ
      double precision EM2, EC2
      COMMON/QUARK/EM2(5),EC2(5,2),NQ
      save /QUARK/
      double precision EM(5)
      data EM/ 0.1D0, 175.D0, 0.d0, 0.d0, 0.d0/
      double precision AU,BU,AD,BD
      double precision  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst / pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      LOGICAL first
      DATA first /.TRUE./
      SAVE first 
      double precision EMCUT2, PIE
      double complex RM1
      COMMON/EMCUT/EMCUT2,PIE,RM1
      data emcut2/1.d0/
      data RM1/(0.D0,1.D0)/
      save /EMCUT/
      double precision eqf(2,-20:20), zff(2,-20:20)
      common /Vboscpl/ eqf, zff

*....
      IF(first) then 
       first = .false.
      NQ = 2
      EM(2) = mq(6)
      DO 767 I=1,NQ
  767 EM2(I)=EM(I)*EM(I)
       PIE = pi
       mz2 = Rpar(46)
       mz4 = Rpar(46)**2
       EPS=(0.0D0,-1.0D-8)
* parameters from Glover's code
*      XW=0.23D0
*      AL = Rpar(11)
*      AL=1.D0/128.D0
*      ALZ=AL/XW/(1.D0-XW)
*      AU=0.25D0-2.D0*XW/3.D0
*      BU=-0.25D0
*      AD=-0.25D0+XW/3.D0
*      BD=0.25D0

* Higgs contribution
      AD = zff(1, 1)
      AU = zff(1, 2)
      BD = zff(2, 1)
      BU = zff(2, 2)

*      EM(1)=0.1D0
*      EM(2)=120.D0
      EC2(1,1)=2.D0*(AU**2+BU**2)+3.D0*(AD**2+BD**2)
      EC2(1,2)=2.D0*(AU**2-BU**2)+3.D0*(AD**2-BD**2)
      EC2(2,1)=AU**2+BU**2
      EC2(2,2)=AU**2-BU**2
      NQ=2
      ENDIF
*
      call varzz(p1,p2,p3,p4)
      Vesm = 0.d0
*       CALL A2GGZZ(S, T, U, A2TT,A2TL,A2LL, VESM)
       CALL A2GGZZ(S, T, U, VESM)
      return
      end
