*----------------------------------------------------------------------------*
*.... H+- decay into f1 f2 (excluding top Bbar)                              *
      subroutine HPM_dec_01(id, kf, MHS) 
*     ----------------------------------                                     *
*                                                                            *
*     PH -> f1  f2~                                                          *
*... input :                                                                 *
*   ID = 1,2,...,21 is type of H+- decay channel                             *
*   KF = 37(-37) is H-boson flavor                                           *
*... output :                                                                *
*............................................................................*

      implicit none
      include "txpar.inc" 
      double precision PH(5), F1(5), F2(5), DH(3)
      double precision Ves, Vs1, MHS 
      double precision PYR
      LOGICAL first
      SAVE first 
      DATA first /.TRUE./
      double precision VesMaX(30), aran 
      save VesMaX 
      integer ires
      save ires
*...........
      double precision mq, mq2
      common/massql/   mq(0:20), mq2(0:20)
      integer II, KF, IX, ID, ju, jd, iz 
*      double precision HCPL,       HCPL2   
*      common/HPMCPL/   HCPL(-20:20), HCPL2(-20:20)
      integer mxdc
      parameter (mxdc=20)   
      integer ndec, kdec, j8,j9
      double precision pdm, pdpl
      common /decmom/ pdm(mxdc,5), pdpl(mxdc,4), ndec, kdec(mxdc,3)
* 
      do j8 = 1,mxdc
       do j9 = 1,3
          pdm(j8,j9) = 0.d0
         pdpl(j8,j9) = 0.d0
         kdec(j8,j9) = 0
       enddo
          pdm(j8,4) = 0.d0
          pdm(j8,5) = 0.d0
         pdpl(j8,4) = 0.d0
      enddo
      ndec = 2 
      ires = 3
      PH(4) = MHS 
      ph(5) = ph(4)
      if(.NOT.first) goto 114 
       do j9 = 1,30
         vesmax(j9) = 0.d0
       enddo

      do 115 ix = 1,mid(0, ires) 
        if(mid(ix, ires).le.-1)    goto 115
         ju = abs(FID(ires,ix,1))
         jd = abs(FID(ires,ix,2)) 
        if(ju.eq.6.or.jd.eq.6)    goto 115
         f1(5) = mq(ju) 
         f2(5) = mq(jd) 

      do ii = 1, ipar(52)
      call LIPS2 (ph, f1, f2, VS1)
      call HPM_ME_01(ju, jd, f1, f2, dh, ves)
       Ves =  VS1 * ves
       if(Ves.gt.VesMax(ix)) VesMax(ix) = Ves 
      enddo
 115  continue 
      first = .false. 

 114  continue 

        iz =  kf / abs(kf)  ! +1(-1) for top (topbar) 
 116   ju = abs(FID(ires,id,1))
       jd = abs(FID(ires,id,2)) 
        if(ju.eq.6.or.jd.eq.6)    goto 116
         f1(5) = mq(ju) 
         f2(5) = mq(jd) 
      call LIPS2 (ph, f1, f2, VS1)
      call HPM_ME_01(ju, jd, f1, f2, dh, ves)
       Ves =  VS1 * ves
       if(Ves.gt.VesMax(id)) VesMax(id) = Ves 
       aran = VesMax(id) * PYR(0) 
       if(Ves.lt.aran) goto 116
 
       kdec(1,1) = iz * FID(ires, ID, 1) ! NU
       kdec(2,1) = iz * FID(ires, ID, 2) ! L+-

      do II = 1,5
       pdm(1,II) = f1(ii)
       pdm(2,II) = f2(ii)
      enddo

      do II = 1,3
       pdm(20,II) = dh(ii)
      enddo

      return
      end
