c----------------------------------------------------------------------------c
*.. author : Serge Slabospitsky   31.01.2002                                 *
*....                                                                        *
      subroutine HPM_Decay(KP, KFH) 
*     ------------------------------------                                   *
*  KP   are position of H-bosons in KUP list                                 *
*  KFH  are KF codes  of H-bosons                                            *
*............................................................................*
      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
      integer kp, kfh, irh, idh, nl1,fc1, nl2,fc2 
      double precision mhs
* first parameter in MID, BRF, FID, and BRS has the meaning as follows
*     IRES = 1 : top quark,  IRES = 2 : W-boson, 
*     IRES = 3 : H+- boson,  IRES = 4 : Z-boson 
      integer mxdc
      parameter (mxdc=20)   
      integer ndec, kdec
      double precision pdm, pdpl
      common /decmom/  pdm(mxdc,5), pdpl(mxdc,4), ndec, kdec(mxdc,3)
*...
*
       irh  = 3        ! H+- 
       call Res_branch (IRH, kfH, Idh) 
* start executing !
      MHS = pup(5,kp) 
      if(idh.eq.11) then
        call HPM_dec_11(KP, kfh)
      else
        call HPM_dec_01(idh, kfh, MHS) 
      endif
      if(idh.eq.11) then
        call COLORF_HFF_11(kp)  
      else
        NL1 = NUP + 1                       ! U(nu) 
        NL2 = NUP + 2                       ! D(l+-)
        fc1 = kdec(1,1)                    ! KF code
        fc2 = kdec(2,1)                    ! KF code
        NUP = NUP + 2
        call colorf_BFF(KP, NL1, FC1, NL2, FC2) 
        call DECHEP(KP, 1, NL1) 
        call DECHEP(KP, 2, NL2) 
      endif      

      return
      end
