*----------------------------------------------------------------------------*
      subroutine HPM_ME_01(il1,il2, l1, l2, dh, ves) 
*     -------------------------------                                        *
*                                                                            *
*   H+ -> nu,U(l1) L+,Dbar(L2)                                               *
*   CKM**2 is included
*............................................................................*

      implicit none

      include "txpar.inc" 
      double precision CKM2
      common /CKMD/    CKM2(-6:6,-6:6)
      double precision mq,       mq2
      common/massql/   mq(0:20), mq2(0:20)
      double precision HCPL,       HCPL2   
      common/HPMCPL/   HCPL(-20:20), HCPL2(-20:20)

      double precision l1(5), l2(5), dh(3), ves, scalp
      double precision lv(4), vh(3,4) 
      integer il1, il2, j
* 
      VES = (hcpl2(il1) + hcpl2(il2))*scalp(l1,l2) 
     & - 2.d0*mq(abs(il1))*mq(abs(il2))*hcpl(il1)*hcpl(il2)

       dh(1) = 0.d0
       dh(2) = 0.d0
       dh(3) = 0.d0
      if(abs(il1).eq.6) then
       do j = 1,4
        lv(j) = ((hcpl2(il1)-hcpl2(il2))*mq(il1)*l2(j))/ves
       enddo
        call vortas(l1, vh)
      do j = 1,3
      dh(j)=lv(4)*vh(j,4)-lv(1)*vh(j,1)-lv(2)*vh(j,2)-lv(3)*vh(j,3)
      if(il1.eq.-6) dh(j) = -dh(j) 
      enddo
      elseif(abs(il2).eq.15) then
       do j = 1,4
        lv(j) = ((hcpl2(il1)-hcpl2(il2))*mq(il2)*l1(j))/ves
       enddo
      call vortas(l2, vh)
      do j = 1,3
      dh(j)=lv(4)*vh(j,4)-lv(1)*vh(j,1)-lv(2)*vh(j,2)-lv(3)*vh(j,3)
      if(il1.eq.-6) dh(j) = -dh(j) 
      enddo
      endif      

       ves = rpar(26)**2 * ves
       if(abs(il1).le.6) ves = ves * 3.d0 * ckm2(il1,il2)
      RETURN
      END
