c----------------------------------------------------------------------------c

      subroutine IBMTG(BM,TG,  IB, IT) 
      implicit none
      CHARACTER*12 BM,TG,  BM2, TG2 
      integer Ib, It 
      integer MAXnum
      PARAMETER (MAXNUM=33)
      character*12 CDHE(maxnum) 
      DATA CDHE/     'e-          ','e+          ','nu_e        ',
     &'nu_ebar     ','mu-         ','mu+         ','nu_mu       ',
     &'nu_mubar    ','tau-        ','tau+        ','nu_tau      ',
     &'nu_taubar   ','pi+         ','pi-         ','n0          ',
     &'nbar0       ','p+          ','pbar-       ','gamma       ',
     &'lambda0     ','sigma-      ','sigma0      ','sigma+      ',
     &'xi-         ','xi0         ','omega-      ','pi0         ',
     &'k+          ','k-          ','ks0         ','kl0         ',
     &'p           ','pbar        '/
      integer KCDE(maxnum) 
      DATA KCDE/      11,            -11,           12,
     & -12,           13,            -13,           14, 
     & -14,           15,            -15,           16,
     & -16,           211,           -211,          2112,
     & -2112,         2212,          -2212,         22,
     &  3122,         3112,           3212,         3222,
     &  3312,         3322,           3334,          111, 
     &  321,         -321,           310,             130,
     & 2212, - 2212/
      integer i 
* transform capital letters to small ones
       bm2 = '            '
       tg2 = '            '
       do i = 1,12 
       if(BM(i:i).ne.' ') then
         if(ichar(BM(i:i)).ge.65.AND.ichar(BM(i:i)).LE.90) then
           BM2(i:i) = char(ichar(BM(i:i))+32)
         else
           BM2(i:i) = BM(i:i)
         endif
       endif
       enddo
       do i = 1,12 
       if(TG(i:i).ne.' ') then
         if(ichar(TG(i:i)).ge.65.AND.ichar(TG(i:i)).LE.90) then
           TG2(i:i) = char(ichar(TG(i:i))+32)
         else
           TG2(i:i) = TG(i:i)
         endif
       endif
       enddo
      Ib = 0
      It = 0
      do I = 1, maxnum
        if(BM2.eq.CDHE(I)) Ib = KCDE(I)
        if(TG2.eq.CDHE(I)) It = KCDE(I)
      enddo
      if(Ib.ne.0.and.It.ne.0) then
        RETURN
      else   
       if(Ib.eq.0) write(*,11) BM
 11    format(//,3x,'TopReX : unknown BEAM = ',a12)
       if(It.eq.0) write(*,12) TG 
 12    format(//,3x,'TopReX : unknown TARGET = ',a12)
       write(*,14)
 14    format(/,3x,'stop run')
      STOP
      endif
      return
      end
