*----------------------------------------------------------------------------*
* product of three complex matrices,  V = A1 * A2 * A3
      subroutine PROD_3ZPGL(iq, A1, A2, v) 
*     ------------------------------                                         *
      implicit none
      double complex A1(4,4), A2(4,4), u(4,4), v(4,4) 
      integer i1, i2, k, iq 
*
     
      do i1 = 1,4
       do i2 = 1,4
        u(i1,i2) = (0.d0, 0.d0)
        v(i1,i2) = (0.d0, 0.d0)
         do k=1,4
          u(i1,i2) = u(i1,i2) + A1(i1,k) * A2(k,i2)
         enddo
       enddo
      enddo
      if(iq.eq.1) then
       v(1,2) =   u(1,3) 
       v(1,4) =  -u(1,1) 
       v(2,2) =   u(2,3) 
       v(2,4) =  -u(2,1) 
       v(3,2) =   u(3,3) 
       v(3,4) =  -u(3,1) 
       v(4,2) =   u(4,3) 
       v(4,4) =  -u(4,1) 
      elseif(iq.eq.2) then
       v(1,1) = -u(1,4)
       v(1,3) =  u(1,2) 
       v(2,1) = -u(2,4)
       v(2,3) =  u(2,2) 
       v(3,1) = -u(3,4)
       v(3,3) =  u(3,2) 
       v(4,1) = -u(4,4)
       v(4,3) =  u(4,2) 
      endif
      RETURN
      END
