*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  30.05.2006                                  *
* the fermion propagator, M*I + p^hat, P(5) = M is the mass of ON-SHELL ferm *
* denominator (m**2 - p**2 - i epsilon) in incserulded                          *
      subroutine PropF2(eps, p, V)
*     ----------------------------                                           *
      implicit none
      double precision p(5), eps, scalp
      double complex V(4,4), PP, PM, P1, P2, p5, zn
      double complex ei 
      data ei/(0.d0, 1.d0)/
      integer i,j
*
       do i=1,4
        do j = 1,4
         v(i,j) = (0.d0, 0.d0)
        enddo
       enddo
*
        zn = p(5)**2 - scalp(p, p) - ei*eps
       P5 =  p(5)              / zn
       Pp = (p(4) + p(3)     ) / zn 
       Pm = (p(4) - p(3)     ) / zn 
       p1 = (p(1) + ei * p(2)) / zn 
       p2 = (p(1) - ei * p(2)) / zn 
      v(1,1) = p5
      v(1,3) = PP
      v(1,4) = p2
 
      v(2,2) = p5
      v(2,3) = p1
      v(2,4) = Pm

      v(3,1) =  Pm
      v(3,2) = -p2
      v(3,3) =  p5

      v(4,1) = -p1
      v(4,2) =  Pp
      v(4,4) =  p5
      RETURN
      END
