
*----------------------------------------------------------------------------*
*.. author : Serge Slabospitsky   06.11.99                                   *
*....                                                                        *
      Function PT(A)
*     --------------                                                         *
*                                                                            *
*  transverse momentum of 4-vector                                           *
*............................................................................*
      Implicit None
      double precision A(5)
      double precision PT
      double precision Pmin
      data Pmin /0.000001/   ! min P_x or P_y
*
      if(abs(A(1)).ge.Pmin.or.abs(A(2)).ge.Pmin) then
       PT = dsqrt( A(1)*A(1) + A(2)*A(2) )
      else
       PT = 0d0
      endif
      return
      end
