*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  14.06.2004                                  *
*  calculates dLIPS4 with denominator                                        *
*  R -> pZ(f1, f2) f3 f4                                                     *
*  ONE denominator is  included                                              *
*  the denominator is (pZ^2-M_Z^2)^2 + (M_Z * Width_Z)^2  due to Z-boson     *
*............................................................................*
      subroutine Rlip423(R, k1, k2, k3, k4, pz, wtR)
*     -------------------------------------------                            *
      implicit none
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst/ pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision R(5), k1(5), k2(5), k3(5), k4(5), pz(5) 
      include "txpar.inc" 
      double precision ves1, ves2,wtr

      pz(5) = rpar(45)
      call Lips3(R,  k3, k4, pz, ves1)
      call Lips2(pz, k1, k2, ves2)
      wtR = ves1 * ves2
      return
      end
