
*----------------------------------------------------------------------------*
      subroutine tfcnc_01uu(iq1, iq2, iq3, imt, p1, p2, p3, p4,ves,hv)
      implicit none
      include "txpar.inc" 
      double precision  p1(5), p2(5)       ! momenta of initial quarks
      double precision  p3(5), p4(5)       ! momenta of Y and top 
      double precision s,t,mt,mt2,mt4,mt6,  epsl(5)
      double complex   FL,     FR,      HL,    HR,
     &                 XL,     XR,      YL,    YR
      common /ANOMCPL/FL(20), FR(20), HL(20), HR(20), 
     &                XL(20), XR(20), YL(20), YR(20) 
      double complex alctCR, alctR, altcR, altcCR, alctCL, alctL,
     &  altcL, altcCL, betc, betcC, bectC, bect
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      integer iq1, iq2, iq3, imt, iqf, J
      double complex U0, a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,
     & a11,a12,a13,a14,a15,a16,a17,a18,
     & b1,b2,b3,b4,b5,b6,b7,b8,b9,b10,
     & b11,b12,b13,b14,b15,b16,b17,b18,b0, egr
      double precision ves, coef, s2,s3, t2,t3,
     & sp(4), vh(3,4), hv(4), lq1, lq2 
      double complex ei 
      data ei/(0.d0, 1.d0)/
      LOGICAL first
      SAVE first, coef, mt,mt2,mt4,mt6
      DATA first /.TRUE./
*******
      IF(first) THEN        ! initializing
        coef = rpar(10) ! transformation 1/GeV**2 to mb 
        coef = coef / (2.d0*2.d0 * 3.d0*3.d0) 
        mt = mq(6)
        mt2 = mt**2
        mt4 = mt**4
        mt6 = mt**6
       print*,'  Contributed code:   '
       print*,'  Rui Santos and Pedro Ferreira --> '
       print*,'  FCNC top-gluon-quark interaction '
       print*,'                     '
       first=.FALSE.
      ENDIF
*
           if(abs(iq3).eq.2) iqf = 11
           if(abs(iq3).eq.4) iqf = 12
*
       s = (p1(4) + p2(4))**2 - (p1(1) + p2(1))**2
     &   - (p1(2) + p2(2))**2 - (p1(3) + p2(3))**2
       s2 = s * s
       s3 = s2 * s  
       t = (p1(4) - p4(4))**2 - (p1(1) - p4(1))**2
     &   - (p1(2) - p4(2))**2 - (p1(3) - p4(3))**2
       t2 = t * t
       t3 = t2 * t

*
*      print*,'iqf ',iqf
*      print*,'HR HL ',HR(iqf),HL(iqf)
*      print*,'XR XL ',XR(iqf),XL(iqf)
*      print*,'YR YL ',YR(iqf),YL(iqf)



       alctCR = XR(iqf) + YR(iqf) ! C_TR(iqf)
       alctR  = conjg(alctCR)

       altcR  = - YR(iqf)         ! C_XR(iqf) - C_TR(iqf)
       altcCR = conjg(altcR)

       alctCL =  XL(iqf) + YL(iqf) ! C_TL(iqf)
       alctL  = conjg(alctCL)

       altcL  = - YL(iqf)          ! C_XL(iqf) - C_TL(iqf)
       altcCL = conjg(altcL)

       betc   = -ei*HR(iqf)        ! C_HR(iqf)
       betcC  = conjg(betc)
       bectC  = -ei*HL(iqf)        ! C_HL(iqf)
       bect   = conjg(bectC)

********************

      a1 = 2*alctCR*altcCR*(3*(s + t)*mt6 - 2*(s2 + 2*t*s + 3*t2)*mt4 
     & + (2*s-3*t)*(3*s - 2*t)*(s+t)*mt2 + s*t*(11*s2 + 16*t*s + 11*t2))

      a2 = 2*alctCR*alctR*(3*(s + t)*mt6 - 6*(s - t)**2*mt4
     & + (s + t)*(6*s2 - t*s + 6*t2)*mt2 - s*t*(11*s2 + 16*t*s + 11*t2))

      a3 = 8*alctCR*betcC*mt*(3*(s + t)*mt4 + (-6*s2 + 4*t*s - 6*t2)*mt2
     &  + (s + t)*(6*s2 - 7*t*s + 6*t2)) 

      a4 = 2*altcCR*altcR*(-3*(s + t)*mt6 + 2*(3*s + t)*(s + 3*t)*mt4
     &  - (s+t)*(6*s2+ 19*t*s + 6*t2)*mt2 +s*t*(11*s2 + 16*t*s + 11*t2))

      a5 = 8*altcCR*betc*mt*(s+t)*(mt4-2*(s + t)*mt2 + 2*s2 + 2*t2+s*t)

      a6 = 2*alctR*altcR  *(3*(s +t)*mt6 - 2*(3*s2 + 2*t*s + 3*t2)*mt4 
     & + (2*s - 3*t)*(3*s-2*t)*(s+t)*mt2 +s*t*(11*s2 + 16*t*s + 11*t2))

      a9 = 2*alctCL*altcCL*(3*(s +t)*mt6 - 2*(3*s2 + 2*t*s + 3*t2)*mt4 
     & + (2*s-3*t)*(3*s - 2*t)*(s +t)*mt2 +s*t*(11*s2 + 16*t*s + 11*t2))

      a7 = 8*altcR*betcC*mt*(s+t)*(mt4-2*(s+t)*mt2 + 2*s2 + 2*t2 +s*t) 

      a8 = 8*alctR*betc*mt*(3*(s +t)*mt4 
     & + (-6*s2 + 4*t*s - 6*t2)*mt2 +(s +t)*(6*s2 - 7*t*s + 6*t2)) 

      a10 = 2*alctCL*alctL*(3*(s +t)*mt6 - 6*(s - t)**2*mt4 
     & + (s +t)*(6*s2 - t*s + 6*t2)*mt2 - s*t*(11*s2 + 16*t*s + 11*t2))

      a11 = 8*alctCL*bect*mt*(3*(s +t)*mt4 +(-6*s2 + 4*t*s - 6*t2)*mt2 
     & + (s +t)*(6*s2 - 7*t*s + 6*t2))

      a12 = 2*altcCL*altcL*(-3*(s +t)*mt6 + 2*(3*s +t)*(s + 3*t)*mt4 
     & - (s+t)*(6*s2+19*t*s + 6*t2)*mt2 +s*t*(11*s2 + 16*t*s + 11*t2))

      a13 = 8*altcCL*bectC*mt*(s+t)*(mt4-2*(s+t)*mt2 + 2*s2 +2*t2 +s*t) 

      a14 = 2*alctL*altcL*(3*(s +t)*mt6 - 2*(3*s2 + 2*t*s + 3*t2)*mt4 
     & + (2*s - 3*t)*(3*s - 2*t)*(s+t)*mt2 +s*t*(11*s2+16*t*s + 11*t2))

      a15 = 8*altcL*bect*mt*(s+t)*(mt4-2*(s+t)*mt2 + 2*s2+2*t2 +s*t)

      a16 = 8*alctL*bectC*mt*(3*(s +t)*mt4 +(-6*s2 + 4*t*s-6*t2)*mt2 
     & + (s +t)*(6*s2 - 7*t*s + 6*t2))

      a17 = 32*bect*bectC*(3*(s +t)*mt4 
     & - 2*(3*s2 + 2*t*s + 3*t2)*mt2 + 2*(s +t)*(3*s2 - t*s + 3*t2)) 

      a18 = 32*betc*betcC*(3*(s +t)*mt4 
     & - 2*(3*s2 + 2*t*s + 3*t2)*mt2 + 2*(s +t)*(3*s2 - t*s + 3*t2))

      U0 = -a1 - a2 -a3 + a4 + 3.d0*ei*a5 - a6 - 3.d0*ei*a7 
     & + ei*a8 - a9 -  a10 -ei*a11 + a12 + 3.d0*ei*a13 
     & - a14 - 3.d0* ei*a15 + ei*a16-a17-a18



* SPIN
      
      call epsil3(p4, p1, p2, EPSL)

      do J = 1,4
      EGR =  2.d0*ei*(4.d0*mt2 - 7*(s-t))*EPSL(j)
      LQ1 = P1(j)
      LQ2 = P2(j)

      b1 = 4*alctCR*altcCR*mt*(LQ2*mt6 + 2*(2*LQ1 +LQ2)*(s - t)*mt4 
     & - 2*((2*LQ1 + 3*LQ2)*s2 + 5*LQ2*t*s +(LQ2 - 2*LQ1)*t2)*mt2 
     & + s*t*(3*s*LQ1 - 3*t*LQ1 + 11*s*LQ2 + 8*LQ2*t) + EGR)

      b2 = 4*alctCR*alctR*mt
     & *(LQ2*mt6 + 2*(2*s*LQ1 - 2*t*LQ1 + 3*s*LQ2 +LQ2*t)*mt4 
     & + LQ2*(-13*s2 + 2*t*s - 13*t2)*mt2 + 7*(LQ1 +LQ2)*t3 
     & + 2*s*(5*LQ1-4*LQ2)*t2 - 7*s3*LQ1 - 2*s2*(5*LQ1 + 9*LQ2)*t)

      b3 = 8*alctCR*betcC* (2*LQ2*mt6 + 8*(s*(LQ1 +LQ2) - LQ1*t)*mt4 
     & - ((4*LQ1 + 19*LQ2)*s2 + 8*LQ2*t*s +(15*LQ2 - 4*LQ1)*t2)*mt2 
     &- 7*(s - t)*(s +t)*(s*LQ1 +(LQ1 +LQ2)*t) + EGR)

      b4 = 4*altcCR*altcR*mt*
     & (LQ2*mt6 +(4*s*LQ1 - 4*t*LQ1 - 2*s*LQ2 - 6*LQ2*t)*mt4 
     & - (s +t)*(8*s*LQ1 - 8*t*LQ1 - s*LQ2 - 9*LQ2*t)*mt2 
     & - 7*(LQ1 +LQ2)*t3 
     & - 4*s*(LQ1 + 2*LQ2)*t2 + 7*s3*LQ1 + 4*s2*(LQ1 - LQ2)*t)

      b5 = 8*altcCR*betc* (2*LQ2*mt6 + 8*(s*LQ1 - (LQ1 +LQ2)*t)*mt4 
     & + ((12*LQ1 + 7*LQ2)*t2 - s2*(12*LQ1 + 5*LQ2))*mt2 
     & + 7*(s - t)*(s +t)*(s*LQ1 +(LQ1 +LQ2)*t) 
     & + EGR)

      b6 = 4*alctR*altcR*mt*(LQ2*mt6 + 2*(2*LQ1 +LQ2)*(s - t)*mt4 
     & - 2*((2*LQ1 + 3*LQ2)*s2 + 5*LQ2*t*s +(LQ2 - 2*LQ1)*t2)*mt2 
     & + s*t*(3*s*LQ1 - 3*t*LQ1 + 11*s*LQ2 + 8*LQ2*t) 
     & - EGR)

      b7 = 8*altcR*betcC*(2*LQ2*mt6 + 8*(s*LQ1 - (LQ1 +LQ2)*t)*mt4 
     & + ((12*LQ1 + 7*LQ2)*t2 - s2*(12*LQ1 + 5*LQ2))*mt2 
     & + 7*(s - t)*(s +t)*(s*LQ1 +(LQ1 +LQ2)*t) 
     & - EGR)

      b8 = 8*alctR*betc*(2*LQ2*mt6 + 8*(s*(LQ1 +LQ2) - LQ1*t)*mt4 
     & - ((4*LQ1 + 19*LQ2)*s2 + 8*LQ2*t*s +(15*LQ2 - 4*LQ1)*t2)*mt2 
     & - 7*(s - t)*(s +t)*(s*LQ1 +(LQ1 +LQ2)*t) 
     &- EGR)

      b9 = 4*alctCL*altcCL*mt*(LQ2*mt6 + 2*(2*LQ1 +LQ2)*(s - t)*mt4 
     & - 2*((2*LQ1 + 3*LQ2)*s2 + 5*LQ2*t*s +(LQ2 - 2*LQ1)*t2)*mt2 
     & + s*t*(3*s*LQ1 - 3*t*LQ1 + 11*s*LQ2 + 8*LQ2*t) 
     & - EGR)

      b10 = 4*alctCL*alctL*mt*(LQ2*mt6 
     & + 2*(2*s*LQ1 - 2*t*LQ1 + 3*s*LQ2 +LQ2*t)*mt4 
     & + LQ2*(-13*s2 + 2*t*s - 13*t2)*mt2 + 7*(LQ1 +LQ2)*t3 
     & + 2*s*(5*LQ1-4*LQ2)*t2-7*s3*LQ1-2*s2*(5*LQ1 + 9*LQ2)*t)

      b11 = 8*alctCL*bect* (2*LQ2*mt6 + 8*(s*(LQ1 +LQ2) - LQ1*t)*mt4 
     & - ((4*LQ1 + 19*LQ2)*s2 + 8*LQ2*t*s +(15*LQ2 - 4*LQ1)*t2)*mt2 
     & - 7*(s - t)*(s +t)*(s*LQ1 +(LQ1 +LQ2)*t) 
     & - EGR)

      b12 = 4*altcCL*altcL*mt*(LQ2*mt6 +(4*s*LQ1 - 4*t*LQ1 - 2*s*LQ2 
     & - 6*LQ2*t)*mt4 
     & - (s +t)*(8*s*LQ1 - 8*t*LQ1 - s*LQ2 - 9*LQ2*t)*mt2 
     & - 7*(LQ1 +LQ2)*t3 
     & - 4*s*(LQ1 + 2*LQ2)*t2 + 7*s3*LQ1 + 4*s2*(LQ1 - LQ2)*t)

      b13= 8*altcCL*bectC* (2*LQ2*mt6 + 8*(s*LQ1 - (LQ1 +LQ2)*t)*mt4 
     & + ((12*LQ1 + 7*LQ2)*t2 - s2*(12*LQ1 + 5*LQ2))*mt2 
     & + 7*(s - t)*(s +t)*(s*LQ1 +(LQ1 +LQ2)*t) 
     & - EGR)

      b14 = 4*alctL*altcL*mt*(LQ2*mt6 + 2*(2*LQ1 +LQ2)*(s - t)*mt4 
     & - 2*((2*LQ1 + 3*LQ2)*s2 + 5*LQ2*t*s +(LQ2 - 2*LQ1)*t2)*mt2 
     & + s*t*(3*s*LQ1 - 3*t*LQ1 + 11*s*LQ2 + 8*LQ2*t) 
     & + EGR)


      b15 = 8*altcL*bect* (2*LQ2*mt6 + 8*(s*LQ1 - (LQ1 +LQ2)*t)*mt4 
     & + ((12*LQ1 + 7*LQ2)*t2 - s2*(12*LQ1 + 5*LQ2))*mt2 
     & + 7*(s - t)*(s +t)*(s*LQ1 +(LQ1 +LQ2)*t) 
     & + EGR)

      b16 = 8*alctL*bectC* (2*LQ2*mt6 + 8*(s*(LQ1 +LQ2) - LQ1*t)*mt4 
     & - ((4*LQ1 + 19*LQ2)*s2 + 8*LQ2*t*s +(15*LQ2 - 4*LQ1)*t2)*mt2 
     & - 7*(s - t)*(s +t)*(s*LQ1 +(LQ1 +LQ2)*t) 
     & + EGR)

      b17 = 64*bect*bectC*mt*(LQ2*mt4 + 2*(2*LQ1 +LQ2)*(s -t)*mt2 
     & - 2*((2*LQ1 + 3*LQ2)*s2 +LQ2*t*s +(LQ2 - 2*LQ1)*t2)) 

      b18 = 64*betc*betcC*mt*(LQ2*mt4 + 2*(2*LQ1 +LQ2)*(s-t)*mt2 
     & - 2*((2*LQ1 + 3*LQ2)*s2 +LQ2*t*s +(LQ2 - 2*LQ1)*t2))


      b0 = -b1 - b2 - ei*b3 - b4 + ei*b5 - b6 - ei*b7 + ei*b8 + b9 + b10 
     &   + ei*b11 - b12 - ei*b13 + b14 + ei*b15 - ei*b16 + b17 - b18
      sp(j) = dble(b0 / u0)
      enddo

      call vortas(p4, vh)
       do j = 1,3
        hv(j) = -(sp(4)*vh(j,4) - sp(1)*vh(j,1) - sp(2)*vh(j,2) 
     &                          - sp(3)*vh(j,3))
       enddo

*      ves = (u0 / 27.d0 /S/T) * coef * rpar(16)**2
      ves = (u0 / 3.d0 / S / T) * coef * rpar(16)**2
      return
      end
