c----------------------------------------------------------------------------c
*.. author : Serge Slabospitsky   06.09.2002                                 *
*.... top decay in to b and H+- (-> bbar t* -> W*)                           *
      subroutine Top_dec_05(kf, MT) 
*     ----------------------------------                                     *
*                                                                            *
*   KFT = 6 (-6)  is top flavor, ITP top position in HEPEUP list             *
*   MT is initial top mass                                                   * 
*   DH(3)  is 3-momentum of polarisation vector                              *
*............................................................................*

      implicit none
      include "txpar.inc" 
      LOGICAL first
      SAVE first 
      DATA first /.TRUE./
      double precision VesMaX(30), aran, scalp, coef
      save VesMaX, coef
      integer ires, kf
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision HCPL,       HCPL2   
      common/HPMCPL/   HCPL(-20:20), HCPL2(-20:20)
      integer mxdc
      parameter (mxdc=20)   
      integer ndec, kdec
      double precision pdm,  pdpl
      common /decmom/ pdm(mxdc,5), pdpl(mxdc,4), ndec, kdec(mxdc,3)

      integer I, II, IX, ID, iz, irw 
      double precision at1,at2, at3, pmm(2), p2s 
      save at1,at2, at3, pmm 
      double precision p2(5), ph(5),k1(5),k2(5),q1(5),l1(5),l2(5) 
      double precision MT, DH(5), axa, Ves, Vs1, PYR
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
* 
      ires = 3
      ndec = 8

      IF(first) then 
      if(ipar(33).ge.2) then
       print*,'*********************************************'
       print*,'*  IPAR(33) value = ',ipar(33)
       print*,'*  is implemented for t -> b H*+- (t* bbar) *'
       print*,'*********************************************'
      endif 
      ENDIF
      if(.NOT.first) goto 114 
        do IX = 1,mid(0, ires)
         VesMax(iX) = 0.d0
        enddo
      coef = rpar(26)**2 / 2.d0
      coef = coef * pi2_3 
      coef = coef * pi2_4 / 2.d0 / mq(6) 
      AT1 = hcpl2(6) + hcpl2(5) 
      AT2 = 2.d0 * mq(5)*mq(6)*hcpl(5)*hcpl(6)
      AT3 = mq(6) * (hcpl2(6) - hcpl2(5)) 


      p2(5) = MT 
      p2(4) = p2(5)
      p2(3) = 0.d0
      p2(2) = 0.d0
      p2(1) = 0.d0
      k2(5) = mq(5)  
      pmm(1) = rpar(70) + 2.d0*mq(5)
      pmm(2) = p2(5) - mq(5)


      do 225 iX = 1,mid(0, 2) 
       if(mid(ix, 2).le.-1) goto 225

      DO ii = 1,ipar(52)
      call brtwig(pmm, rpar(51), rpar(53), VS1, p2s)
       ves = coef * VS1 
       ph(5) = p2s
      call LIPS2 (p2, k2, ph,  VS1) 
       ves = ves * VS1 
       call HPM_ME_03(ix, ph, k1, q1, l1, l2, dh, vs1) 
       ves = ves * VS1 * (at1*scalp(p2,k2) + at2)
      if(ves.gt.vesmax(ix)) vesmax(ix) = ves 
      ENDDO
 225  continue

      first = .false. 

 114  continue
      irw  = 2       ! W+-
      call Res_branch (IRW, kf, id) 
*
      call brtwig(pmm, rpar(51), rpar(53), VS1, p2s)
       ves = coef * VS1 
       ph(5) = p2s
      call LIPS2 (p2, k2, ph,  VS1) 
       ves = ves * VS1 
       call HPM_ME_03(id, ph, k1, q1, l1, l2, dh, vs1) 
       axa = at1*scalp(p2,k2) + at2
       ves = ves * VS1 * axa 
      if(ves.gt.vesmax(id)) vesmax(id) = ves 
      aran = vesmax(id) * pyr(0)
      if(aran.gt.ves) goto 114

        iz =  kf / abs(kf)  ! +1(-1) for top (topbar) 

       kdec(1,1) = iz *  5            ! B-quark from initial top
       kdec(2,1) = iz * 37            ! H-boson
       kdec(3,1) = iz * (-5)          ! Bbar-quark from H+-
       kdec(4,1) = kf                 ! second top* 
       kdec(5,1) = iz * 24            ! W from second top  
       kdec(6,1) = iz *  5            ! B-quark from second top  
       kdec(7,1) = iz*FID(irw, ID, 1) ! NU, U
       kdec(8,1) = iz*FID(irw, ID, 2) ! L+, Dbar

      do I = 1,5
       pdm(1,I) = k2(i) 
       pdm(2,I) = ph(i) 
       pdm(3,I) = q1(i) 
       pdm(4,I) = k1(i) + l1(I) + l2(I) 
       pdm(5,I) = L1(I) + L2(I) 
       pdm(6,I) = K1(i)
       pdm(7,I) = L1(i)
       pdm(8,I) = L2(i)
       pdm(20,I) = at3 * k2(i) / AXA
        if(kf.eq.-6) pdm(20,I) = -pdm(20,I) 
      enddo
       pdm(4,5) = dsqrt(pdm(4,4)**2 - pdm(4,1)**2
     &                - pdm(4,2)**2 - pdm(4,3)**2)
       pdm(5,5) = dsqrt(pdm(5,4)**2 - pdm(5,1)**2
     &                - pdm(5,2)**2 - pdm(5,3)**2)
       RETURN
       END
