c----------------------------------------------------------------------------c
*.. author : Serge Slabospitsky   03.02.2001                                 *
*....                                                                        *
      subroutine Top_Decay(Ntop, KPP, KFT) 
*     ------------------------------------                                   *
*  NTOP is number of t-quarks                                                *
*  KPP  are position of t-quarks in HEPEUP list                              *
*  KFT  are KF code of top quarks                                            *
*............................................................................*
      implicit none
      integer Ntop, IR, KPP(2) , kft(2) 
      integer id1, kp1, kft1 !, iqs1 
      integer id2, kp2, kft2 !, iqs2 
*.........

      if(ntop.eq.1) then 
       Ir  = 1       ! top
       kp1  = KPP(1)
       kft1 = kft(1) 
       call Res_branch (IR, kft1, Id1) 
       call top_rdec_1(id1, Kp1) 
      elseif(ntop.eq.2) then 
       IR  = 1       ! top 
       kp1  = KPP(1)
       kft1 = KFT(1) 
       call Res_branch (IR, kft1, Id1) 
       kp2  = KPP(2)
       kft2 = KFT(2) 
       call Res_branch (IR, kft2, Id2) 
       call top_rdec_2(id1, id2, kp1, kp2) 
      else
       write(*,10) Ntop 
 10    format('  wrong number of decaying top quarks',
     &3x,' stop TopReX running ')
          STOP
      endif
      return
      end
