
c----------------------------------------------------------------------------*
*... author  :  Serge Slabospitsky                                           *
*... 08.04.2002                                                              *
*............................................................................*
*
      Subroutine tx_mtch2(pt0) 
      Implicit None
      integer    nd
      parameter (ND=50) 
      double precision ptmin,ptmax,xpt 
      double precision nh1, nh2 
      common /ahist/nh1(nd), nh2(nd), xpt(nd)
      double precision z0,z1,z2,z3,z4,al1,b1,al2,b2,pt0,alx 
      common /promtch/ptmin, ptmax
      integer I 
*   fitting
      pt0 = 0.d0
      z0 = 0.d0
      z1 = 0.d0
      z2 = 0.d0
      z3 = 0.d0
      z4 = 0.d0
      do I = 1,nd
       if(nh1(i).eq.0) goto 221
       z0 = z0 + 1.d0*nh1(i)
       z1 = z1 + xpt(i)*nh1(i)
       z2 = z2 + xpt(i)**2*nh1(i)
       z3 = z3 + dlog(nh1(i)) * nh1(i)
       z4 = z4 + xpt(i)*dlog(nh1(i)) * nh1(i)
 221	continue
      enddo
      alx = z0*z2 - z1*z1
      if(abs(alx).le.0.000001) return
      al1 = (z2*z3 - z1*z4) / alx
      b1  = (z1*z3 - z0*z4) / alx
*
      z0 = 0.d0
      z1 = 0.d0
      z2 = 0.d0
      z3 = 0.d0
      z4 = 0.d0
      do I = 1,nd
       if(nh2(i).eq.0) goto 222
       z0 = z0 + 1.d0*nh2(i)
       z1 = z1 + xpt(i)*nh2(i)
       z2 = z2 + xpt(i)**2*nh2(i)
       z3 = z3 + dlog(nh2(i)) * nh2(i)
       z4 = z4 + xpt(i)*dlog(nh2(i)) * nh2(i)
 222	continue
      enddo
      alx = z0*z2 - z1*z1
      if(abs(alx).le.0.000001) return
      al2 = (z2*z3 - z1*z4) / alx
      b2  = (z1*z3 - z0*z4) / alx
      pt0 = (al2 - al1) / (b2 - b1)
      return
      end
