
*----------------------------------------------------------------------------*
* Matrix element: g g -> Z Q(k3) Qbar(k4), Z -> f(k1) fbar(k2) 
      subroutine ZGGtoQQ(kfk1, kfk3,q1,q2,ak1,ak2,ak3,ak4, ves) 
*     -------------------------------------------                            *
      implicit none
      include "txpar.inc"
      double precision q1(5), q2(5), k1(5), k2(5), k3(5), k4(5)
      double precision ak1(5),ak2(5),ak3(5),ak4(5), rr(5)
      double precision u1(5), u2(5), u3(5), u4(5) 
      double precision pz(5), q2z, Q2gl
      double precision VES 
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision scalp, denZ
      integer kfk1, kfk3
      integer J, iq1, iq2, ik1, ik2, ik3, ik4
      integer j1, j2, j3, j4, j5, j6         
      double complex PHM_u1(4,4), PHM_u2(4,4), PHM_u3(4,4), PHM_u4(4,4) 
      double complex KUB1(2,4), KUB3(2,4), KV2(2,4), KV4(2,4)
      double complex cgV, czV, czA 
      double complex UU, UU1, UU2, UU3, UU4,
     & TA1(2,2,2,2,2,2), TB1(2,2,2,2,2,2), TC1(2,2,2,2), 
     & TA2(2,2,2,2,2,2), TB2(2,2,2,2,2,2), TC2(2,2,2,2), 
     & TA3(2,2,2,2,2,2), TB3(2,2,2,2,2,2), TC3(2,2,2,2), 
     & TA4(2,2,2,2,2,2), TB4(2,2,2,2,2,2), TC4(2,2,2,2) 
      double complex UZB(4,4),V1(4,4),V2(4,4),V3(4,4), Q1Q2(4,4) 
      double complex VV1(4,4),VV(4,4),VV3(4,4) 
      double complex VS1(4,4),VS2(4,4),VS3(4,4)
      double complex HGA(2,2,4), HGZ(2,2,4)
      double complex GZK(2,2,4,4)
      double precision coef0, coef 
      SAVE coef0, coef 
      double complex ei 
      data ei/(0.d0, 1.d0)/
      double precision eqf(2,-20:20), zff(2,-20:20) 
      save eqf, zff
      double precision eqf0(2,-20:20), zff0(2,-20:20)
      common /Vboscpl/ eqf0, zff0
      double complex g4(4,4),g1(4,4),g2(4,4),g3(4,4),g5(4,4)
      common /gmatr/g4, g1, g2, g3, g5
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
      double precision zn1, zn2
      COMMON /colden/ zn1, zn2
      save /colden/
* test
      double precision zv1(5), zv2(5), zv3(5), zv4(5),wa,wb,TTT
*
      if(first) THEN
      do j1 = 1,2
      do j = 1,20
         eqf(j1,j) = eqf0(j1,j)
         zff(j1,j) = zff0(j1,j)
        if(Ipar(23).eq.1) then    
          zff(j1,j) = 0.d0  ! only gamma
        endif 
        if(Ipar(23).eq.2) then    
          eqf(j1,j) = 0.d0  ! only Z-boson
        endif 
      enddo
      enddo

       call gamdir

        coef0 = Rpar(10) / (2.d0 * 2.d0)  ! spins
        coef0 = coef0 / (8.d0 * 8.d0)    ! colors 
      first=.FALSE.
      ENDIF


      if(abs(kfk1).le.6) then
        if(kfk1.eq.kfk3) then
         coef = coef0 / 4.d0  ! z -> q qbar two pairs of identical qq~qq~
        else
         coef = 3.d0 * coef0  ! z -> q qbar 
        endif
      elseif(abs(kfk1).ge.11) then
       coef = coef0  ! z -> l+ li or nu nubar
      endif

* evaluate Dirac spinors
       do j = 1,5
        k1(j) = ak1(j)
        k2(j) = ak2(j)
        k3(j) = ak3(j)
        k4(j) = ak4(j)
       enddo

       do j = 1,4
        rr(j) = q1(j) - q2(j)
        pz(j) = k1(j) + k2(j)
        u1(j) = pz(j) + k3(j) 
        u2(j) = q2(j) - k4(j)
        u3(j) = k3(j) - q1(j)
        u4(j) = -k4(j) - pz(j)
       enddo
        u1(5) = k3(5)
        u2(5) = k3(5)
        zn1 = k3(5)**2 - scalp(u2,u2)
        u3(5) = k3(5)
        u4(5) = k3(5)
        pz(5) = rpar(45)
        q2z = scalp(pz, pz)
        q2gl = (q1(4)+q2(4))**2 - (q1(1)+q2(1))**2
     &       - (q1(2)+q2(2))**2 - (q1(3)+q2(3))**2
        denZ = (rpar(46) - q2z)**2 + rpar(48)**2 
* test
       goto 334
       do j = 1,4
        zv1(j) = scalp(q1,k4)*q2(j) + scalp(q2,k4)*q1(j)
        zv1(j) = zv1(j) / scalp(q1,q2)
       enddo

       do j = 1,4
        zv2(j) = k3(5)**2 * zv1(j) + 2.d0*k3(5)**2*u2(j)
     & + 2.d0*scalp(u2,zv1)*u2(j) - scalp(u2,u2)*zv1(j)
       enddo

       wa = scalp(zv1,q1)
       wa = scalp(zv1,q2)
       wa = k3(5)**3 + 2.d0*k3(5)*scalp(zv1,u2) 
     & + k3(5)*scalp(u2,u2)
       do j = 1,4
        zv3(j) = - scalp(q1,zv2)*q2(j)
     &         - scalp(q2,zv2)*q1(j)
        zv3(j) = zv3(j) / scalp(q1,q2)
       enddo

       do j = 1,4
        zv4(j) = k3(5)**2 * zv3(j) + 2.d0*k3(5)*wa*u1(j)
     & + 2.d0*scalp(u1,zv3)*u1(j) - scalp(u1,u1)*zv3(j)
       enddo
       wb = wa*k3(5)**2 + 2.d0*k3(5)*scalp(zv3,u1) 
     & + wa*scalp(u1,u1)

       ttt = 4.d0*8.d0*4.d0*(-k3(5)*wb*scalp(k1,k2)
     & + scalp(k1,k3)*scalp(k2,zv4)
     & + scalp(k2,k3)*scalp(k1,zv4))
       ttt = ttt / (scalp(u1,u1)-k3(5)**2)**2
       ttt = ttt / (scalp(u2,u2)-k3(5)**2)**2
*      ves = -ttt * coef * denZ * rpar(16)**2 * 
      ves = -ttt * coef * rpar(16)**2 * 
     & eqf(2,kfk1)**2 * eqf(2,kfk3)**2 /q2z**2 
*      return
 334   continue

*
      call Dirs_Ubar(k1, KUB1)
      call Dirs_Ubar(k3, KUB3)
      call Dirs_V(k2, KV2)
      call Dirs_V(k4, KV4)

      call Phat(rr, Q1Q2)
      call Propf(u1, phm_u1)
      call Propf(u2, phm_u2)
      call Propf(u3, phm_u3)
      call Propf(u4, phm_u4)

*
       cgV = eqf(2,kfk1)/Q2z
       czV = zff(1,kfk1)/(Q2z - rpar(46) + ei*rpar(48))
       czA = zff(2,kfk1)/(Q2z - rpar(46) + ei*rpar(48))
       call Us_ZbA_Uc(PZ, cgv, czv, cza, KUB1, KV2, HGA, HGZ) 
       cgV = eqf(2,kfk3) 
       czV = zff(1,kfk3)
       czA = zff(2,kfk3)
       call MATR_ZbA(cgV, czV, czA, HGA, HGZ, GZK) 

      do 1001 iq1 = 1,2
        call prod_EhatA(iq1, phm_u3, V3)
        call prod_EhatA(iq1, phm_u2, VV)
        call prod_2(phm_u1, VV, V1)
      do 1001 iq2 = 1,2
        call prod_AEhat(iq2, phm_u2, V2)
        call prod_AEhat(iq2, V1, VV1)

        call prod_AEhat(iq2, V3, VV)
        call prod_2(VV, phm_u4, VV3)
      do 1002 ik1 = 1,2
      do 1002 ik2 = 1,2
        call V4toU(ik1, ik2, GZK, UZB) 

        call prod_2(UZB, VV1, VS1) 
        call prod_2(VV3, UZB, VS3) 
        call prod_2(V3, UZB, VV) 
        call prod_2(VV, V2, VS2) 

       call Matr_Add_2(VS1, VS2, VV)
       call Matr_Add_2(VV, VS3, VS1)
      do 1003 ik3 = 1,2
      do 1003 ik4 = 1,2
       call Us_M_Uc(ik3,ik4, KUB3, VS1, KV4, UU)
       TA1(iq1,iq2,ik1,ik2,ik3,ik4) = UU
 1003 continue 
 1002 continue 
 1001 continue 

       call prod_2(phm_u1, q1q2, V1) 
       call prod_2(q1q2, phm_u4, V2) 
      do 1011 ik1 = 1,2
      do 1011 ik2 = 1,2
        call V4toU(ik1, ik2, GZK, UZB) 
        call prod_2(UZB, V1, VS1) 
        call prod_2(V2, UZB, VS2) 
       call Matr_Add_2(VS1, VS2, VS3)
      do 1011 ik3 = 1,2
      do 1011 ik4 = 1,2
       call Us_M_Uc(ik3,ik4, KUB3, VS3, KV4, UU)
       TC1(ik1,ik2,ik3,ik4) = UU
 1011 continue 
**
*  gluon1 <==> gluon2
       do j = 1,4
        u2(j) = q1(j) - k4(j)
        u3(j) = k3(j) - q2(j)
       enddo
        zn2 = k3(5)**2 - scalp(u2,u2)

      call Propf(u2, phm_u2)
      call Propf(u3, phm_u3)
*
      do 1021 iq2 = 1,2
        call prod_EhatA(iq2, phm_u3, V3)
        call prod_EhatA(iq2, phm_u2, VV)
        call prod_2(phm_u1, VV, V1)
      do 1021 iq1 = 1,2
        call prod_AEhat(iq1, phm_u2, V2)
        call prod_AEhat(iq1, V1, VV1)

        call prod_AEhat(iq1, V3, VV)
        call prod_2(VV, phm_u4, VV3)
      do 1022 ik1 = 1,2
      do 1022 ik2 = 1,2
        call V4toU(ik1, ik2, GZK, UZB) 

        call prod_2(UZB, VV1, VS1) 
        call prod_2(VV3, UZB, VS3) 
        call prod_2(V3, UZB, VV) 
        call prod_2(VV, V2, VS2) 

       call Matr_Add_2(VS1, VS2, VV)
       call Matr_Add_2(VV, VS3, VS1)
      do 1023 ik3 = 1,2
      do 1023 ik4 = 1,2
       call Us_M_Uc(ik3,ik4, KUB3, VS1, KV4, UU)
       TB1(iq1,iq2,ik1,ik2,ik3,ik4) = UU
 1023 continue 
 1022 continue 
 1021 continue 

       if(kfk1.eq.kfk3) goto 2000
      ves = 0.d0
      do 111 j1 = 1,2 
      do 111 j2 = 1,2 
      do 111 j3 = 1,2 
      do 111 j4 = 1,2 
      do 111 j5 = 1,2 
      do 111 j6 = 1,2 
      UU = TA1(j1,j2,j3,j4,j5,j6) + TB1(j1,j2,j3,j4,j5,j6)
         ves = ves + (7.d0/3.d0) * UU * conjg(UU)

      UU = TA1(j1,j2,j3,j4,j5,j6) - TB1(j1,j2,j3,j4,j5,j6)
      if(j1.eq.j2) then
        UU = UU - 2.d0*TC1(j3,j4,j5,j6) / Q2gl
      endif
      ves = ves + 3.d0 * UU * conjg(UU)
 111  continue
      ves = ves * coef * rpar(16)**2 
      return
*  indentical final quarks, start permutations

 2000 continue
*      z -> k1 k4     + k3 k2
       do j = 1,5
        k1(j) = ak1(j)
        k2(j) = ak4(j)
        k3(j) = ak3(j)
        k4(j) = ak2(j)
       enddo

       do j = 1,4
        pz(j) = k1(j) + k2(j)
        u1(j) = pz(j) + k3(j) 
        u2(j) = q2(j) - k4(j)
        u3(j) = k3(j) - q1(j)
        u4(j) = -k4(j) - pz(j)
       enddo
        u1(5) = k3(5)
        u2(5) = k3(5)
        u3(5) = k3(5)
        u4(5) = k3(5)
        pz(5) = rpar(45)
        q2z = scalp(pz, pz)
*
      call Dirs_Ubar(k1, KUB1)
      call Dirs_Ubar(k3, KUB3)
      call Dirs_V(k2, KV2)
      call Dirs_V(k4, KV4)

      call Propf(u1, phm_u1)
      call Propf(u2, phm_u2)
      call Propf(u3, phm_u3)
      call Propf(u4, phm_u4)

*
       cgV = eqf(2,kfk1)/Q2z
       czV = zff(1,kfk1)/(Q2z - rpar(46) + ei*rpar(48))
       czA = zff(2,kfk1)/(Q2z - rpar(46) + ei*rpar(48))
       call Us_ZbA_Uc(PZ, cgv, czv, cza, KUB1, KV2, HGA, HGZ) 

       cgV = eqf(2,kfk3) 
       czV = zff(1,kfk3)
       czA = zff(2,kfk3)
       call MATR_ZbA(cgV, czV, czA, HGA, HGZ, GZK) 

      do 1201 iq1 = 1,2
        call prod_EhatA(iq1, phm_u3, V3)
        call prod_EhatA(iq1, phm_u2, VV)
        call prod_2(phm_u1, VV, V1)
      do 1201 iq2 = 1,2
        call prod_AEhat(iq2, phm_u2, V2)
        call prod_AEhat(iq2, V1, VV1)

        call prod_AEhat(iq2, V3, VV)
        call prod_2(VV, phm_u4, VV3)
      do 1202 ik1 = 1,2
      do 1202 ik2 = 1,2
        call V4toU(ik1, ik2, GZK, UZB) 

        call prod_2(UZB, VV1, VS1) 
        call prod_2(VV3, UZB, VS3) 
        call prod_2(V3, UZB, VV) 
        call prod_2(VV, V2, VS2) 

       call Matr_Add_2(VS1, VS2, VV)
       call Matr_Add_2(VV, VS3, VS1)
      do 1203 ik3 = 1,2
      do 1203 ik4 = 1,2
       call Us_M_Uc(ik3,ik4, KUB3, VS1, KV4, UU)
       TA2(iq1,iq2,ik1,ik2,ik3,ik4) = -UU
 1203 continue 
 1202 continue 
 1201 continue 

       call prod_2(phm_u1, q1q2, V1) 
       call prod_2(q1q2, phm_u4, V2) 
      do 1211 ik1 = 1,2
      do 1211 ik2 = 1,2
        call V4toU(ik1, ik2, GZK, UZB) 
        call prod_2(UZB, V1, VS1) 
        call prod_2(V2, UZB, VS2) 
       call Matr_Add_2(VS1, VS2, VS3)
      do 1211 ik3 = 1,2
      do 1211 ik4 = 1,2
       call Us_M_Uc(ik3,ik4, KUB3, VS3, KV4, UU)
       TC2(ik1,ik2,ik3,ik4) = -UU
 1211 continue 
**
*  gluon1 <==> gluon2
       do j = 1,4
        u2(j) = q1(j) - k4(j)
        u3(j) = k3(j) - q2(j)
       enddo

      call Propf(u2, phm_u2)
      call Propf(u3, phm_u3)
*
      do 1221 iq2 = 1,2
        call prod_EhatA(iq2, phm_u3, V3)
        call prod_EhatA(iq2, phm_u2, VV)
        call prod_2(phm_u1, VV, V1)
      do 1221 iq1 = 1,2
        call prod_AEhat(iq1, phm_u2, V2)
        call prod_AEhat(iq1, V1, VV1)

        call prod_AEhat(iq1, V3, VV)
        call prod_2(VV, phm_u4, VV3)
      do 1222 ik1 = 1,2
      do 1222 ik2 = 1,2
        call V4toU(ik1, ik2, GZK, UZB) 

        call prod_2(UZB, VV1, VS1) 
        call prod_2(VV3, UZB, VS3) 
        call prod_2(V3, UZB, VV) 
        call prod_2(VV, V2, VS2) 

       call Matr_Add_2(VS1, VS2, VV)
       call Matr_Add_2(VV, VS3, VS1)
      do 1223 ik3 = 1,2
      do 1223 ik4 = 1,2
       call Us_M_Uc(ik3,ik4, KUB3, VS1, KV4, UU)
       TB2(iq1,iq2,ik1,ik2,ik3,ik4) = -UU
 1223 continue 
 1222 continue 
 1221 continue 

*      z -> k3 k2     + k1 k4
       do j = 1,5
        k1(j) = ak3(j)
        k2(j) = ak2(j)
        k3(j) = ak1(j)
        k4(j) = ak4(j)
       enddo

       do j = 1,4
        pz(j) = k1(j) + k2(j)
        u1(j) = pz(j) + k3(j) 
        u2(j) = q2(j) - k4(j)
        u3(j) = k3(j) - q1(j)
        u4(j) = -k4(j) - pz(j)
       enddo
        u1(5) = k3(5)
        u2(5) = k3(5)
        u3(5) = k3(5)
        u4(5) = k3(5)
        pz(5) = rpar(45)
        q2z = scalp(pz, pz)
*
      call Dirs_Ubar(k1, KUB1)
      call Dirs_Ubar(k3, KUB3)
      call Dirs_V(k2, KV2)
      call Dirs_V(k4, KV4)

      call Propf(u1, phm_u1)
      call Propf(u2, phm_u2)
      call Propf(u3, phm_u3)
      call Propf(u4, phm_u4)

*
       cgV = eqf(2,kfk1)/Q2z
       czV = zff(1,kfk1)/(Q2z - rpar(46) + ei*rpar(48))
       czA = zff(2,kfk1)/(Q2z - rpar(46) + ei*rpar(48))
       call Us_ZbA_Uc(PZ, cgv, czv, cza, KUB1, KV2, HGA, HGZ) 

       cgV = eqf(2,kfk3) 
       czV = zff(1,kfk3)
       czA = zff(2,kfk3)
       call MATR_ZbA(cgV, czV, czA, HGA, HGZ, GZK) 

      do 1301 iq1 = 1,2
        call prod_EhatA(iq1, phm_u3, V3)
        call prod_EhatA(iq1, phm_u2, VV)
        call prod_2(phm_u1, VV, V1)
      do 1301 iq2 = 1,2
        call prod_AEhat(iq2, phm_u2, V2)
        call prod_AEhat(iq2, V1, VV1)

        call prod_AEhat(iq2, V3, VV)
        call prod_2(VV, phm_u4, VV3)
      do 1302 ik1 = 1,2
      do 1302 ik2 = 1,2
        call V4toU(ik1, ik2, GZK, UZB) 

        call prod_2(UZB, VV1, VS1) 
        call prod_2(VV3, UZB, VS3) 
        call prod_2(V3, UZB, VV) 
        call prod_2(VV, V2, VS2) 

       call Matr_Add_2(VS1, VS2, VV)
       call Matr_Add_2(VV, VS3, VS1)
      do 1303 ik3 = 1,2
      do 1303 ik4 = 1,2
       call Us_M_Uc(ik3,ik4, KUB3, VS1, KV4, UU)
       TA3(iq1,iq2,ik1,ik2,ik3,ik4) = -UU
 1303 continue 
 1302 continue 
 1301 continue 

       call prod_2(phm_u1, q1q2, V1) 
       call prod_2(q1q2, phm_u4, V2) 
      do 1311 ik1 = 1,2
      do 1311 ik2 = 1,2
        call V4toU(ik1, ik2, GZK, UZB) 
        call prod_2(UZB, V1, VS1) 
        call prod_2(V2, UZB, VS2) 
       call Matr_Add_2(VS1, VS2, VS3)
      do 1311 ik3 = 1,2
      do 1311 ik4 = 1,2
       call Us_M_Uc(ik3,ik4, KUB3, VS3, KV4, UU)
       TC3(ik1,ik2,ik3,ik4) = -UU
 1311 continue 
**
*  gluon1 <==> gluon2
       do j = 1,4
        u2(j) = q1(j) - k4(j)
        u3(j) = k3(j) - q2(j)
       enddo

      call Propf(u2, phm_u2)
      call Propf(u3, phm_u3)
*
      do 1321 iq2 = 1,2
        call prod_EhatA(iq2, phm_u3, V3)
        call prod_EhatA(iq2, phm_u2, VV)
        call prod_2(phm_u1, VV, V1)
      do 1321 iq1 = 1,2
        call prod_AEhat(iq1, phm_u2, V2)
        call prod_AEhat(iq1, V1, VV1)

        call prod_AEhat(iq1, V3, VV)
        call prod_2(VV, phm_u4, VV3)
      do 1322 ik1 = 1,2
      do 1322 ik2 = 1,2
        call V4toU(ik1, ik2, GZK, UZB) 

        call prod_2(UZB, VV1, VS1) 
        call prod_2(VV3, UZB, VS3) 
        call prod_2(V3, UZB, VV) 
        call prod_2(VV, V2, VS2) 

       call Matr_Add_2(VS1, VS2, VV)
       call Matr_Add_2(VV, VS3, VS1)
      do 1323 ik3 = 1,2
      do 1323 ik4 = 1,2
       call Us_M_Uc(ik3,ik4, KUB3, VS1, KV4, UU)
       TB3(iq1,iq2,ik1,ik2,ik3,ik4) = -UU
 1323 continue 
 1322 continue 
 1321 continue 

*      z -> k3 k4     + k1 k2
       do j = 1,5
        k1(j) = ak3(j)
        k2(j) = ak4(j)
        k3(j) = ak1(j)
        k4(j) = ak2(j)
       enddo

       do j = 1,4
        pz(j) = k1(j) + k2(j)
        u1(j) = pz(j) + k3(j) 
        u2(j) = q2(j) - k4(j)
        u3(j) = k3(j) - q1(j)
        u4(j) = -k4(j) - pz(j)
       enddo
        u1(5) = k3(5)
        u2(5) = k3(5)
        u3(5) = k3(5)
        u4(5) = k3(5)
        pz(5) = rpar(45)
        q2z = scalp(pz, pz)
*
      call Dirs_Ubar(k1, KUB1)
      call Dirs_Ubar(k3, KUB3)
      call Dirs_V(k2, KV2)
      call Dirs_V(k4, KV4)

      call Propf(u1, phm_u1)
      call Propf(u2, phm_u2)
      call Propf(u3, phm_u3)
      call Propf(u4, phm_u4)

*
       cgV = eqf(2,kfk1)/Q2z
       czV = zff(1,kfk1)/(Q2z - rpar(46) + ei*rpar(48))
       czA = zff(2,kfk1)/(Q2z - rpar(46) + ei*rpar(48))
       call Us_ZbA_Uc(PZ, cgv, czv, cza, KUB1, KV2, HGA, HGZ) 

       cgV = eqf(2,kfk3) 
       czV = zff(1,kfk3)
       czA = zff(2,kfk3)
       call MATR_ZbA(cgV, czV, czA, HGA, HGZ, GZK) 

      do 1401 iq1 = 1,2
        call prod_EhatA(iq1, phm_u3, V3)
        call prod_EhatA(iq1, phm_u2, VV)
        call prod_2(phm_u1, VV, V1)
      do 1401 iq2 = 1,2
        call prod_AEhat(iq2, phm_u2, V2)
        call prod_AEhat(iq2, V1, VV1)

        call prod_AEhat(iq2, V3, VV)
        call prod_2(VV, phm_u4, VV3)
      do 1402 ik1 = 1,2
      do 1402 ik2 = 1,2
        call V4toU(ik1, ik2, GZK, UZB) 

        call prod_2(UZB, VV1, VS1) 
        call prod_2(VV3, UZB, VS3) 
        call prod_2(V3, UZB, VV) 
        call prod_2(VV, V2, VS2) 

       call Matr_Add_2(VS1, VS2, VV)
       call Matr_Add_2(VV, VS3, VS1)
      do 1403 ik3 = 1,2
      do 1403 ik4 = 1,2
       call Us_M_Uc(ik3,ik4, KUB3, VS1, KV4, UU)
       TA4(iq1,iq2,ik1,ik2,ik3,ik4) = UU
 1403 continue 
 1402 continue 
 1401 continue 

       call prod_2(phm_u1, q1q2, V1) 
       call prod_2(q1q2, phm_u4, V2) 
      do 1411 ik1 = 1,2
      do 1411 ik2 = 1,2
        call V4toU(ik1, ik2, GZK, UZB) 
        call prod_2(UZB, V1, VS1) 
        call prod_2(V2, UZB, VS2) 
       call Matr_Add_2(VS1, VS2, VS3)
      do 1411 ik3 = 1,2
      do 1411 ik4 = 1,2
       call Us_M_Uc(ik3,ik4, KUB3, VS3, KV4, UU)
       TC4(ik1,ik2,ik3,ik4) = UU
 1411 continue 
**
*  gluon1 <==> gluon2
       do j = 1,4
        u2(j) = q1(j) - k4(j)
        u3(j) = k3(j) - q2(j)
       enddo

      call Propf(u2, phm_u2)
      call Propf(u3, phm_u3)
*
      do 1421 iq2 = 1,2
        call prod_EhatA(iq2, phm_u3, V3)
        call prod_EhatA(iq2, phm_u2, VV)
        call prod_2(phm_u1, VV, V1)
      do 1421 iq1 = 1,2
        call prod_AEhat(iq1, phm_u2, V2)
        call prod_AEhat(iq1, V1, VV1)

        call prod_AEhat(iq1, V3, VV)
        call prod_2(VV, phm_u4, VV3)
      do 1422 ik1 = 1,2
      do 1422 ik2 = 1,2
        call V4toU(ik1, ik2, GZK, UZB) 

        call prod_2(UZB, VV1, VS1) 
        call prod_2(VV3, UZB, VS3) 
        call prod_2(V3, UZB, VV) 
        call prod_2(VV, V2, VS2) 

       call Matr_Add_2(VS1, VS2, VV)
       call Matr_Add_2(VV, VS3, VS1)
      do 1423 ik3 = 1,2
      do 1423 ik4 = 1,2
       call Us_M_Uc(ik3,ik4, KUB3, VS1, KV4, UU)
       TB4(iq1,iq2,ik1,ik2,ik3,ik4) = UU
 1423 continue 
 1422 continue 
 1421 continue 
*********
      ves = 0.d0
      do 211 j1 = 1,2 
      do 211 j2 = 1,2 
      do 211 j3 = 1,2 
      do 211 j4 = 1,2 
      do 211 j5 = 1,2 
      do 211 j6 = 1,2 
      UU1 = TA1(j1,j2,j3,j4,j5,j6) + TB1(j1,j2,j3,j4,j5,j6)
      UU2 = TA2(j1,j2,j3,j4,j5,j6) + TB2(j1,j2,j3,j4,j5,j6)
      UU3 = TA3(j1,j2,j3,j4,j5,j6) + TB3(j1,j2,j3,j4,j5,j6)
      UU4 = TA4(j1,j2,j3,j4,j5,j6) + TB4(j1,j2,j3,j4,j5,j6)
         ves = ves + (7.d0/3.d0) * 
     & (  2.d0* UU1*conjg(UU1) + 2.d0*UU2*conjg(UU2)
     &  + 2.d0* UU3*conjg(UU3) + 2.d0*UU4*conjg(UU4)
     &  + (UU1+UU2+UU3+UU4)*conjg(UU1+UU2+UU3+UU4)
     &  - UU1*conjg(UU4) - UU4*conjg(UU1)
     &  - UU2*conjg(UU3) - UU3*conjg(UU2))

      UU1 = TA1(j1,j2,j3,j4,j5,j6) - TB1(j1,j2,j3,j4,j5,j6)
      UU2 = TA2(j1,j2,j3,j4,j5,j6) - TB2(j1,j2,j3,j4,j5,j6)
      UU3 = TA3(j1,j2,j3,j4,j5,j6) - TB3(j1,j2,j3,j4,j5,j6)
      UU4 = TA4(j1,j2,j3,j4,j5,j6) - TB4(j1,j2,j3,j4,j5,j6)
      if(j1.eq.j2) then
        UU1 = UU1 - 2.d0*TC1(j3,j4,j5,j6) / Q2gl
        UU2 = UU2 - 2.d0*TC2(j3,j4,j5,j6) / Q2gl
        UU3 = UU3 - 2.d0*TC3(j3,j4,j5,j6) / Q2gl
        UU4 = UU4 - 2.d0*TC4(j3,j4,j5,j6) / Q2gl
      endif

      ves = ves + 3.d0 * 
     & (  2.d0* UU1*conjg(UU1) + 2.d0*UU2*conjg(UU2)
     &  + 2.d0* UU3*conjg(UU3) + 2.d0*UU4*conjg(UU4)
     &  + (UU1+UU2+UU3+UU4)*conjg(UU1+UU2+UU3+UU4)
     &  - UU1*conjg(UU4) - UU4*conjg(UU1)
     &  - UU2*conjg(UU3) - UU3*conjg(UU2))
 211  continue
      ves = ves * coef * rpar(16)**2 
      return
      end       
