
*----------------------------------------------------------------------------*
* Matrix element:   q qbar -> Z Q(k3) Qbar(k4), Z -> f(k1) fbar(k2) 
      subroutine ZqqtoQQ(kfq1, kfk1, kfk3,q1,q2,ak1,ak2,ak3,ak4, ves) 
*     -------------------------------------------                            *
      implicit none
      include "txpar.inc"
      double precision q1(5), q2(5), k1(5), k2(5), k3(5), k4(5)
      double precision ak1(5),ak2(5),ak3(5),ak4(5)
      double precision x1(5), x2(5), x3(5), x4(5),ng(6)
      double precision pg1(5), q2g1, pg2(5), q2g2, pz1(5), q2z1
      double precision VES 
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision scalp, denZ
      integer kfq1, kfk1, kfk3
      integer I,J, iq1, iq2, ik1, ik2, ik3, ik4
      double complex PHM_x1(4,4), PHM_x2(4,4), PHM_x3(4,4), PHM_x4(4,4) 
      double complex KUB1(2,4), KUB3(2,4), KV2(2,4), KV4(2,4),
     &               QVB2(2,4), QU1(2,4)
      double complex cgV, czV, czA, cgl1, cgl2
      double complex UU, TM1(2,2,2,2,2,2) 
      double complex TM2(2,2,2,2,2,2), TM3(2,2,2,2,2,2), 
     &               TM4(2,2,2,2,2,2) 
      double complex U1(4,4),U2(4,4),UZB(4,4),UGL(4,4),VS(4,4) 
      double complex HGA(2,2,4), HGZ(2,2,4)
      double complex GZQ(2,2,4,4), GZK(2,2,4,4), GLK(2,2,4,4)
      double precision coef0, coef 
      SAVE coef0, coef 
      double complex ei 
      data ei/(0.d0, 1.d0)/
      double precision eqf(2,-20:20), zff(2,-20:20) 
      save eqf, zff
      double precision eqf0(2,-20:20), zff0(2,-20:20)
      common /Vboscpl/ eqf0, zff0
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
* test
      double precision v1(5), v2(5), TTT 
*
      if(first) THEN
*       call Vbosoncpl 
      do i = 1,2
      do j = 1,20
         eqf(i,j) = eqf0(i,j)
         zff(i,j) = zff0(i,j)
        if(Ipar(23).eq.1) then    
          zff(i,j) = 0.d0  ! only gamma
        endif 
        if(Ipar(23).eq.2) then    
          eqf(i,j) = 0.d0  ! only Z-boson
        endif 
      enddo
      enddo

       coef0 =  Rpar(10) / (2.d0 * 2.d0)  ! spins
       coef0 = coef0 * 2.d0 / (3.d0 * 3.d0)    ! colors 
      first=.FALSE.
      ENDIF

      
      if(abs(kfk1).le.6) then
        if(kfk1.eq.kfk3) then
         coef = coef0 / 4.d0 ! z -> q qbar two pairs of identical qq~qq~
        else
         coef = 3.d0 * coef0  ! z -> q qbar 
        endif
      elseif(abs(kfk1).ge.11) then
       coef = coef0  ! z -> l+ li or nu nubar
      endif
* evaluate Dirac spinors
       do j = 1,5
        k1(j) = ak1(j)
        k2(j) = ak2(j)
        k3(j) = ak3(j)
        k4(j) = ak4(j)
       enddo

       do j = 1,4
        pg1(j) = k3(j) + k4(j)
        pg2(j) = q1(j) + q2(j)
        ng(j)  = q1(j) + q2(j) 
        pz1(j) = k1(j) + k2(j)
        x1(j)  = q1(j) - pz1(j)
        x2(j)  = q1(j) - pg1(j)
        x3(j)  =  k3(j) + pz1(j)
        x4(j)  = -k4(j) - pz1(j)
       enddo
        x1(5) = q1(5)
        x2(5) = q1(5)
        x3(5) = k3(5)
        x4(5) = k3(5)

        pz1(5) = rpar(45)
        pg1(5) = dsqrt(scalp(pg1,pg1))
        q2z1 = scalp(pz1, pz1)
        denZ = (rpar(46) - q2z1)**2 + rpar(48)**2 
        q2g1 = scalp(pg1, pg1)
        q2g2 = scalp(pg2, pg2)
        ng(5)=ng(4)*ng(4) -ng(1)*ng(1) -ng(2)*ng(2) -ng(3)*ng(3)
        ng(6)=ng(4)*pg1(4)-ng(1)*pg1(1)-ng(2)*pg1(2)-ng(3)*pg1(3)
*

* test
       goto 2001
       do j = 1,4
        v1(j) = scalp(q1,k1)*k2(j) + scalp(q1,k2)*k1(j)  
     &        + q1(j)*k1(5)**2
        v2(j) = scalp(q2,k3)*k4(j) + scalp(q2,k4)*k3(j)  
     &        + q2(j)*k3(5)**2
       enddo
      ttt = 256.d0 * (2.d0*scalp(v1,x1)*scalp(v2,x1)
     & - scalp(x1,x1)*scalp(v1,v2))
      ttt = ttt /(x1(5)**2-scalp(x1,x1))**2
 2001 continue
      call Dirs_Ubar(k1, KUB1)
      call Dirs_Ubar(k3, KUB3)
      call Dirs_V(k2, KV2)
      call Dirs_V(k4, KV4)
      call Dirs_Vbar(q2, QVB2)
      call Dirs_U(q1,    QU1)
      call Propf(x1, phm_x1)
      call Propf(x2, phm_x2)
      call Propf(x3, phm_x3)
      call Propf(x4, phm_x4)
*
       cgV = eqf(2,kfk1)/Q2z1
       czV = zff(1,kfk1)/(Q2z1 - rpar(46) + ei*rpar(48))
       czA = zff(2,kfk1)/(Q2z1 - rpar(46) + ei*rpar(48))
       call Us_ZbA_Uc(PZ1, cgv, czv, cza, KUB1, KV2, HGA, HGZ) 

       cgV = eqf(2,kfq1) 
       czV = zff(1,kfq1)
       czA = zff(2,kfq1)
       call MATR_ZbA(cgV, czV, czA, HGA, HGZ, GZQ) 

       cgV = eqf(2,kfk3) 
       czV = zff(1,kfk3)
       czA = zff(2,kfk3)
       call MATR_ZbA(cgV, czV, czA, HGA, HGZ, GZK) 

       cgl1 = rpar(16) / Q2g1 
       call Us_gluon_Uc(pg1, ng, cgl1, KUB3, KV4, GLK) 

       cgl2 = rpar(16) / Q2g2 
      do 1000 ik1 = 1,2
      do 1000 ik2 = 1,2
       call V4toU(ik1, ik2, GZQ, UZB) 
      do 1000 ik3 = 1,2
      do 1000 ik4 = 1,2
       call V4toU(ik3, ik4, GLK, UGL) 
       call prod_3XPY(UGL, phm_x1, UZB, U1)
       call prod_3XPY(UZB, phm_x2, UGL, U2)
       call Matr_Add_2(U1, U2, VS)
*
      if(q1(3).gt.0.d0) then
       TM1(1,1,ik1,ik2,ik3,ik4) = -VS(4,1) 
       TM1(1,2,ik1,ik2,ik3,ik4) = -VS(4,4) 
       TM1(2,1,ik1,ik2,ik3,ik4) = -VS(1,1) 
       TM1(2,2,ik1,ik2,ik3,ik4) = -VS(1,4) 
      elseif(q1(3).lt.0.d0) then
       TM1(1,1,ik1,ik2,ik3,ik4) = VS(2,3) 
       TM1(1,2,ik1,ik2,ik3,ik4) = VS(2,2) 
       TM1(2,1,ik1,ik2,ik3,ik4) = VS(3,3) 
       TM1(2,2,ik1,ik2,ik3,ik4) = VS(3,2) 
      endif      
 1000  continue

      do 1001 ik1 = 1,2
      do 1001 ik2 = 1,2
       call V4toU(ik1, ik2, GZK, UZB) 
      do 1001 iq1 = 1,2
      do 1001 iq2 = 1,2
       if(iq1.ne.iq2) goto 1003
       call prod_3ZPGL(iq1, UZB, phm_x3, U1)
       call prod_3GLPZ(iq1, phm_x4, UZB, U2)
       call Matr_Add_2(U1, U2, VS)
      do 1002 ik3 = 1,2
      do 1002 ik4 = 1,2
       call Us_M_Uc(ik3,ik4, KUB3, VS, KV4, UU)
       TM1(iq1,iq2,ik1,ik2,ik3,ik4) = 
     & TM1(iq1,iq2,ik1,ik2,ik3,ik4) + 2.d0 * cgl2 * UU
 1002  continue
 1003  continue
 1001  continue

       if(kfk1.eq.kfk3) goto 2000
      ves = 0.d0
      do 1010 iq1 = 1,2
      do 1010 iq2 = 1,2
      do 1010 ik1 = 1,2
      do 1010 ik2 = 1,2
      do 1010 ik3 = 1,2
      do 1010 ik4 = 1,2
       ves = ves  + TM1(iq1,iq2,ik1,ik2,ik3,ik4)   
     &      * conjg(TM1(iq1,iq2,ik1,ik2,ik3,ik4))
 1010  continue
      ves = ves * coef * 4.d0 * q1(4) * q2(4)
      return

 2000 continue
       do j = 1,5
        k1(j) = ak1(j)
        k2(j) = ak4(j)
        k3(j) = ak3(j)
        k4(j) = ak2(j)
       enddo

       do j = 1,4
        pg1(j) = k3(j) + k4(j)
        pz1(j) = k1(j) + k2(j)
        x1(j)  = q1(j) - pz1(j)
        x2(j)  = q1(j) - pg1(j)
        x3(j)  =  k3(j) + pz1(j)
        x4(j)  = -k4(j) - pz1(j)
       enddo
        x1(5) = q1(5)
        x2(5) = q1(5)
        x3(5) = k3(5)
        x4(5) = k3(5)

        pz1(5) = rpar(45)
        pg1(5) = dsqrt(scalp(pg1,pg1))
        q2z1 = scalp(pz1, pz1)
*        denZ = (rpar(46) - q2z1)**2 + rpar(48)**2 
        q2g1 = scalp(pg1, pg1)
*        ng(5)=ng(4)*ng(4) -ng(1)*ng(1) -ng(2)*ng(2) -ng(3)*ng(3)
        ng(6)=ng(4)*pg1(4)-ng(1)*pg1(1)-ng(2)*pg1(2)-ng(3)*pg1(3)
*

      call Dirs_Ubar(k1, KUB1)
      call Dirs_Ubar(k3, KUB3)
      call Dirs_V(k2, KV2)
      call Dirs_V(k4, KV4)
*      call Dirs_Vbar(q2, QVB2)
*      call Dirs_U(q1,    QU1)
      call Propf(x1, phm_x1)
      call Propf(x2, phm_x2)
      call Propf(x3, phm_x3)
      call Propf(x4, phm_x4)
*
       cgV = eqf(2,kfk1)/Q2z1
       czV = zff(1,kfk1)/(Q2z1 - rpar(46) + ei*rpar(48))
       czA = zff(2,kfk1)/(Q2z1 - rpar(46) + ei*rpar(48))
       call Us_ZbA_Uc(PZ1, cgv, czv, cza, KUB1, KV2, HGA, HGZ) 

       cgV = eqf(2,kfq1) 
       czV = zff(1,kfq1)
       czA = zff(2,kfq1)
       call MATR_ZbA(cgV, czV, czA, HGA, HGZ, GZQ) 

       cgV = eqf(2,kfk3) 
       czV = zff(1,kfk3)
       czA = zff(2,kfk3)
       call MATR_ZbA(cgV, czV, czA, HGA, HGZ, GZK) 

       cgl1 = pi4 * rpar(15) / Q2g1 
       call Us_gluon_Uc(pg1, ng, cgl1, KUB3, KV4, GLK) 

      do 1100 ik1 = 1,2
      do 1100 ik2 = 1,2
       call V4toU(ik1, ik2, GZQ, UZB) 
      do 1100 ik3 = 1,2
      do 1100 ik4 = 1,2
       call V4toU(ik3, ik4, GLK, UGL) 
       call prod_3XPY(UGL, phm_x1, UZB, U1)
       call prod_3XPY(UZB, phm_x2, UGL, U2)
       call Matr_Add_2(U1, U2, VS)
*
      if(q1(3).gt.0.d0) then
       TM2(1,1,ik1,ik2,ik3,ik4) = -VS(4,1) 
       TM2(1,2,ik1,ik2,ik3,ik4) = -VS(4,4)
       TM2(2,1,ik1,ik2,ik3,ik4) = -VS(1,1) 
       TM2(2,2,ik1,ik2,ik3,ik4) = -VS(1,4) 
      elseif(q1(3).lt.0.d0) then
       TM2(1,1,ik1,ik2,ik3,ik4) =  VS(2,3) 
       TM2(1,2,ik1,ik2,ik3,ik4) =  VS(2,2) 
       TM2(2,1,ik1,ik2,ik3,ik4) =  VS(3,3) 
       TM2(2,2,ik1,ik2,ik3,ik4) =  VS(3,2) 
      endif      
 1100  continue

      do 1101 ik1 = 1,2
      do 1101 ik2 = 1,2
       call V4toU(ik1, ik2, GZK, UZB) 
      do 1101 iq1 = 1,2
      do 1101 iq2 = 1,2
       if(iq1.ne.iq2) goto 1103
       call prod_3ZPGL(iq1, UZB, phm_x3, U1)
       call prod_3GLPZ(iq1, phm_x4, UZB, U2)
       call Matr_Add_2(U1, U2, VS)
      do 1102 ik3 = 1,2
      do 1102 ik4 = 1,2
       call Us_M_Uc(ik3,ik4, KUB3, VS, KV4, UU)
       TM2(iq1,iq2,ik1,ik2,ik3,ik4) = -(
     & TM2(iq1,iq2,ik1,ik2,ik3,ik4) + 2.d0 * cgl2 * UU)
 1102  continue
 1103  continue
 1101  continue
* k1 ==> k3 
       do j = 1,5
        k1(j) = ak3(j)
        k2(j) = ak2(j)
        k3(j) = ak1(j)
        k4(j) = ak4(j)
       enddo

       do j = 1,4
        pg1(j) = k3(j) + k4(j)
        pz1(j) = k1(j) + k2(j)
        x1(j)  = q1(j) - pz1(j)
        x2(j)  = q1(j) - pg1(j)
        x3(j)  =  k3(j) + pz1(j)
        x4(j)  = -k4(j) - pz1(j)
       enddo
        x3(5) = k3(5)
        x4(5) = k3(5)

        pz1(5) = rpar(45)
        pg1(5) = dsqrt(scalp(pg1,pg1))
        q2z1 = scalp(pz1, pz1)
*        denZ = (rpar(46) - q2z1)**2 + rpar(48)**2 
        q2g1 = scalp(pg1, pg1)
        ng(6)=ng(4)*pg1(4)-ng(1)*pg1(1)-ng(2)*pg1(2)-ng(3)*pg1(3)
      call Dirs_Ubar(k1, KUB1)
      call Dirs_Ubar(k3, KUB3)
      call Dirs_V(k2, KV2)
      call Dirs_V(k4, KV4)
      call Propf(x1, phm_x1)
      call Propf(x2, phm_x2)
      call Propf(x3, phm_x3)
      call Propf(x4, phm_x4)
*
       cgV = eqf(2,kfk1)/Q2z1
       czV = zff(1,kfk1)/(Q2z1 - rpar(46) + ei*rpar(48))
       czA = zff(2,kfk1)/(Q2z1 - rpar(46) + ei*rpar(48))
       call Us_ZbA_Uc(PZ1, cgv, czv, cza, KUB1, KV2, HGA, HGZ) 

       cgV = eqf(2,kfq1) 
       czV = zff(1,kfq1)
       czA = zff(2,kfq1)
       call MATR_ZbA(cgV, czV, czA, HGA, HGZ, GZQ) 

       cgV = eqf(2,kfk3) 
       czV = zff(1,kfk3)
       czA = zff(2,kfk3)
       call MATR_ZbA(cgV, czV, czA, HGA, HGZ, GZK) 

       cgl1 = pi4 * rpar(15) / Q2g1 
       call Us_gluon_Uc(pg1, ng, cgl1, KUB3, KV4, GLK) 

*       cgl2 = pi4 * rpar(15) / Q2g2 
      do 1200 ik1 = 1,2
      do 1200 ik2 = 1,2
       call V4toU(ik1, ik2, GZQ, UZB) 
      do 1200 ik3 = 1,2
      do 1200 ik4 = 1,2
       call V4toU(ik3, ik4, GLK, UGL) 
       call prod_3XPY(UGL, phm_x1, UZB, U1)
       call prod_3XPY(UZB, phm_x2, UGL, U2)
       call Matr_Add_2(U1, U2, VS)
*
      if(q1(3).gt.0.d0) then
       TM3(1,1,ik1,ik2,ik3,ik4) = -VS(4,1) 
       TM3(1,2,ik1,ik2,ik3,ik4) = -VS(4,4) 
       TM3(2,1,ik1,ik2,ik3,ik4) = -VS(1,1) 
       TM3(2,2,ik1,ik2,ik3,ik4) = -VS(1,4) 
      elseif(q1(3).lt.0.d0) then
       TM3(1,1,ik1,ik2,ik3,ik4) = VS(2,3) 
       TM3(1,2,ik1,ik2,ik3,ik4) = VS(2,2) 
       TM3(2,1,ik1,ik2,ik3,ik4) = VS(3,3) 
       TM3(2,2,ik1,ik2,ik3,ik4) = VS(3,2) 
      endif      
 1200  continue

      do 1201 ik1 = 1,2
      do 1201 ik2 = 1,2
       call V4toU(ik1, ik2, GZK, UZB) 
      do 1201 iq1 = 1,2
      do 1201 iq2 = 1,2
       if(iq1.ne.iq2) goto 1203
       call prod_3ZPGL(iq1, UZB, phm_x3, U1)
       call prod_3GLPZ(iq1, phm_x4, UZB, U2)
       call Matr_Add_2(U1, U2, VS)
      do 1202 ik3 = 1,2
      do 1202 ik4 = 1,2
       call Us_M_Uc(ik3,ik4, KUB3, VS, KV4, UU)
       TM3(iq1,iq2,ik1,ik2,ik3,ik4) = -(
     & TM3(iq1,iq2,ik1,ik2,ik3,ik4) + 2.d0 * cgl2 * UU)
 1202  continue
 1203  continue
 1201  continue
* 
* k1 ==> k3 k2 ==> k4
       do j = 1,5
        k1(j) = ak3(j)
        k2(j) = ak4(j)
        k3(j) = ak1(j)
        k4(j) = ak2(j)
       enddo

       do j = 1,4
        pg1(j) = k3(j) + k4(j)
        pz1(j) = k1(j) + k2(j)
        x1(j)  = q1(j) - pz1(j)
        x2(j)  = q1(j) - pg1(j)
        x3(j)  =  k3(j) + pz1(j)
        x4(j)  = -k4(j) - pz1(j)
       enddo
        x3(5) = k3(5)
        x4(5) = k3(5)

        pz1(5) = rpar(45)
        pg1(5) = dsqrt(scalp(pg1,pg1))
        q2z1 = scalp(pz1, pz1)
*        denZ = (rpar(46) - q2z1)**2 + rpar(48)**2 
        q2g1 = scalp(pg1, pg1)
        ng(6)=ng(4)*pg1(4)-ng(1)*pg1(1)-ng(2)*pg1(2)-ng(3)*pg1(3)
      call Dirs_Ubar(k1, KUB1)
      call Dirs_Ubar(k3, KUB3)
      call Dirs_V(k2, KV2)
      call Dirs_V(k4, KV4)
      call Propf(x1, phm_x1)
      call Propf(x2, phm_x2)
      call Propf(x3, phm_x3)
      call Propf(x4, phm_x4)
*
       cgV = eqf(2,kfk1)/Q2z1
       czV = zff(1,kfk1)/(Q2z1 - rpar(46) + ei*rpar(48))
       czA = zff(2,kfk1)/(Q2z1 - rpar(46) + ei*rpar(48))
       call Us_ZbA_Uc(PZ1, cgv, czv, cza, KUB1, KV2, HGA, HGZ) 

       cgV = eqf(2,kfq1) 
       czV = zff(1,kfq1)
       czA = zff(2,kfq1)
       call MATR_ZbA(cgV, czV, czA, HGA, HGZ, GZQ) 

       cgV = eqf(2,kfk3) 
       czV = zff(1,kfk3)
       czA = zff(2,kfk3)
       call MATR_ZbA(cgV, czV, czA, HGA, HGZ, GZK) 

       cgl1 = pi4 * rpar(15) / Q2g1 
       call Us_gluon_Uc(pg1, ng, cgl1, KUB3, KV4, GLK) 

      do 1300 ik1 = 1,2
      do 1300 ik2 = 1,2
       call V4toU(ik1, ik2, GZQ, UZB) 
      do 1300 ik3 = 1,2
      do 1300 ik4 = 1,2
       call V4toU(ik3, ik4, GLK, UGL) 
       call prod_3XPY(UGL, phm_x1, UZB, U1)
       call prod_3XPY(UZB, phm_x2, UGL, U2)
       call Matr_Add_2(U1, U2, VS)
*
      if(q1(3).gt.0.d0) then
       TM4(1,1,ik1,ik2,ik3,ik4) = -VS(4,1) 
       TM4(1,2,ik1,ik2,ik3,ik4) = -VS(4,4) 
       TM4(2,1,ik1,ik2,ik3,ik4) = -VS(1,1) 
       TM4(2,2,ik1,ik2,ik3,ik4) = -VS(1,4) 
      elseif(q1(3).lt.0.d0) then
       TM4(1,1,ik1,ik2,ik3,ik4) = VS(2,3) 
       TM4(1,2,ik1,ik2,ik3,ik4) = VS(2,2) 
       TM4(2,1,ik1,ik2,ik3,ik4) = VS(3,3) 
       TM4(2,2,ik1,ik2,ik3,ik4) = VS(3,2) 
      endif      
 1300  continue

      do 1301 ik1 = 1,2
      do 1301 ik2 = 1,2
       call V4toU(ik1, ik2, GZK, UZB) 
      do 1301 iq1 = 1,2
      do 1301 iq2 = 1,2
       if(iq1.ne.iq2) goto 1303
       call prod_3ZPGL(iq1, UZB, phm_x3, U1)
       call prod_3GLPZ(iq1, phm_x4, UZB, U2)
       call Matr_Add_2(U1, U2, VS)
      do 1302 ik3 = 1,2
      do 1302 ik4 = 1,2
       call Us_M_Uc(ik3,ik4, KUB3, VS, KV4, UU)
       TM4(iq1,iq2,ik1,ik2,ik3,ik4) = 
     & TM4(iq1,iq2,ik1,ik2,ik3,ik4) + 2.d0 * cgl2 * UU
 1302  continue
 1303  continue
 1301  continue
* 
      ves = 0.d0
      do 2011 iq1 = 1,2
      do 2011 iq2 = 1,2
       if(iq1.ne.iq2) goto 2011
      do 2010 ik1 = 1,2
      do 2010 ik2 = 1,2
      do 2010 ik3 = 1,2
      do 2010 ik4 = 1,2
       ves = ves  
     &+ 2.d0*(TM1(iq1,iq2,ik1,ik2,ik3,ik4)   
     & *conjg(TM1(iq1,iq2,ik1,ik2,ik3,ik4)))
     &+ 2.d0*(TM2(iq1,iq2,ik1,ik2,ik3,ik4)   
     & *conjg(TM2(iq1,iq2,ik1,ik2,ik3,ik4)))  
     &+ 2.d0*(TM3(iq1,iq2,ik1,ik2,ik3,ik4)   
     & *conjg(TM3(iq1,iq2,ik1,ik2,ik3,ik4)))
     &+ 2.d0*(TM4(iq1,iq2,ik1,ik2,ik3,ik4)   
     & *conjg(TM4(iq1,iq2,ik1,ik2,ik3,ik4)))  
     & + (  TM1(iq1,iq2,ik1,ik2,ik3,ik4)   
     &    + TM2(iq1,iq2,ik1,ik2,ik3,ik4)
     &    + TM3(iq1,iq2,ik1,ik2,ik3,ik4)
     &    + TM4(iq1,iq2,ik1,ik2,ik3,ik4))*conjg
     &   (  TM1(iq1,iq2,ik1,ik2,ik3,ik4)   
     &    + TM2(iq1,iq2,ik1,ik2,ik3,ik4)
     &    + TM3(iq1,iq2,ik1,ik2,ik3,ik4)
     &    + TM4(iq1,iq2,ik1,ik2,ik3,ik4))
     &    -   TM1(iq1,iq2,ik1,ik2,ik3,ik4)   
     & * conjg(TM4(iq1,iq2,ik1,ik2,ik3,ik4))
     &    -   TM4(iq1,iq2,ik1,ik2,ik3,ik4)   
     & * conjg(TM1(iq1,iq2,ik1,ik2,ik3,ik4))
     &    -    TM2(iq1,iq2,ik1,ik2,ik3,ik4)   
     & * conjg(TM3(iq1,iq2,ik1,ik2,ik3,ik4))
     &    -    TM3(iq1,iq2,ik1,ik2,ik3,ik4)   
     & * conjg(TM2(iq1,iq2,ik1,ik2,ik3,ik4))
 2010  continue
 2011  continue
      ves = ves * coef * 4.d0 * q1(4) * q2(4)
      RETURN
      END
