*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  04.06.2002                                  *
*   b b_bar  -->  t(pol)  + t_bar(pol)                                       *
*----------------------------------------------------------------------------*
      subroutine bbttbar(q1, q2, p1, p2, ves)
*     --------------------------------------------                           *
      implicit none
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision HCPL,       HCPL2   
      common/HPMCPL/   HCPL(-20:20), HCPL2(-20:20)
      double precision q1(5), q2(5)   ! momenta of initial gluons 
      double precision p1(5), p2(5)   ! momenta of final t and tbar 
      double precision Ves, coefg, coefv, mt2, mb2, scalp 
      save coefg, coefv  
      double precision TG, TW, TH 
      double precision S, A, B, p1p2, q1q2   ! A = q1p1      B = q2p1
      double precision zw, zh 
      LOGICAL first
      DATA first /.TRUE./
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
*
      if(first) THEN
        coefg = pi4**2          ! due to alpha_s
        coefg = coefG * rpar(10)               ! transform into millibarns
        coefg = coefG * 2.d0 
       coefV  = rpar(10)*(rpar(26)**2 / 2.d0)**2
       coefV = 9.d0 * coefV 
        coefG = coefG / (3.d0*3.d0*2.d0*2.d0)   ! color & spin
        coefV = coefV / (3.d0*3.d0*2.d0*2.d0)   ! color & spin
        first=.FALSE.
      ENDIF

   
      mt2 = p1(5)**2
      mb2 = q1(5)**2
      p1p2 = SCALP(P1, P2)
      q1q2 = SCALP(Q1, Q2)
      S = 2.d0*(mt2 + p1p2 ) 
      A = SCALP(P1, Q1) 
      B = SCALP(P1, Q2)
      zw = mb2 + mt2 - 2.d0*A - rpar(42)
      zh = mb2 + mt2 - 2.d0*A - rpar(52)

      TG = 2.d0*mb2*mt2 + mb2*p1p2 + mt2*q1q2 + A*A + B*B 
      TG = 32.d0 * rpar(15)**2 * coefg * TG / S / S 

      TW = 16.d0 * B**2 
     & + (8.d0/rpar(42))*(mb2**2*p1p2+mt2**2*q1q2-2.d0*mb2*mt2*B)
     & + (4.d0/rpar(42)**2)*( (mb2+mt2)*A - 2.d0*mb2*mt2)**2
      TW = coefV * TW / zw**2

      TH = 4.d0 * (2.d0*q1(5)*p1(5)*hcpl(5)*hcpl(6)
     &   + (hcpl2(5)+hcpl2(6))*A)**2
      TH = coefV * TH / zh**2

*      ves = TG + TW + TH
      ves = TH 

      return
      end
