c...~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

*----------------------------------------------------------------------------*
*  routines COLORF_...                                                       *
*   color flow and showering description for PYTHIA                          *
*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  05.09.2002                                  *
* Single top: t-channel : 2 -> 2                                             *
*   TopReX code = 1                                                          *
*   color flow and showering description for PYTHIA                          *
      subroutine COLORF_01(ip1, ip2)
*     ------------------------------                                         *
*............................................................................*
      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      integer I, ip1, ip2, iqp, aip1, aip2, ntop, kpp(2), kftop(2) 
*.................  W g  :   2 -> 2 .........................................*
*     q(b)[1] ---------O----------  q`[4]                                    *
*                      <                                                     *
*                      >  W* (t-channel)  : not stored in list               *
*                      <                                                     * 
*     b(q)[2] ---------O==========  T [3]                                    *
*............................................................................*

* HEPEUP :        1     2       3     4 
*       nup = 4 ! q(b)  b(q) -> t(t~) q' 
* how PYTHIA will be treated
        istup(3) =  2 ! final top 
        istup(4) =  1 ! final q'
* parent's lines
          mothup(1,3)=1  ! final top
          mothup(2,3)=2  !
           mothup(1,4)=1  ! final q'
           mothup(2,4)=2  !
* KF code
* colors flow
        ipar(50) = 300
        aip1 = abs(ip1)
        aip2 = abs(ip2)
        icolup(1,1) = (ipar(50)+1)*(aip1+ip1)/2/aip1 ! color 
        icolup(2,1) = (ipar(50)+1)*(aip1-ip1)/2/aip1 ! anticolor 
        icolup(1,2) = (ipar(50)+2)*(aip2+ip2)/2/aip2 ! color 
        icolup(2,2) = (ipar(50)+2)*(aip2-ip2)/2/aip2 ! anticolor 
      if(abs(ip1).eq.5) then  
* B[1] Q[2]
        idup(3) = 6 * ip1 / aip1
        call qflqw(ip2, iqp)
        idup(4) = iqp
* color flow
         icolup(1,3) =  icolup(1,1)  ! b    => t
         icolup(2,3) =  icolup(2,1)  ! bbar => tbar
         icolup(1,4) =  icolup(1,2)  ! q    => q'
         icolup(2,4) =  icolup(2,2)  ! qbar => q'bar
      else 
* q[1] b[2]
        idup(3) = 6 * ip2 / aip2
        call qflqw(ip1, iqp)
        idup(4) = iqp
* color flow
         icolup(1,3) =  icolup(1,2)  ! b    => t
         icolup(2,3) =  icolup(2,2)  ! bbar => tbar
         icolup(1,4) =  icolup(1,1)  ! q    => q'
         icolup(2,4) =  icolup(2,1)  ! qbar => q'bar
      endif  
      pup(5,4) = mq(abs(iqp))
*
      ntop = 0
      do I = 3, Nup
       if(abs(idup(I)).eq.6) then
        ntop = ntop + 1
        kpp(ntop) = I
        kftop(ntop) = idup(i)
       endif 
      enddo
       if(ntop.ge.1) then
        call top_decay(ntop, kpp, kftop) 
       else 
        STOP ! no top quark
       endif
      return
      end
