*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  17/02/2005                                  *
*   Z Z --> f3 f3bar   f4 f4bar                                              *
*   TopReX code = 24                                                         *
      subroutine colorf_24(ip1,ip2)
*     -----------------------------                                          *
*                                                                            *
*  g(1) g(2) --> Z1(3) Z2(4), Z1(3) -> f3 f3bar, Z(4) -> f4 f4bar            *
*                                                                            *
*............................................................................*
      implicit none
      include "hepeup.inc"
      include "txpar.inc" 
      integer ip1, ip2, if3, if4, ires, kv, idz
*
      ires = 4
        istup(3) = 2  ! final Z1 
        istup(4) = 2  ! final Z2 
        istup(5) = 1  ! final f3 
        istup(6) = 1  ! final f3bar 
        istup(7) = 1  ! final f4 
        istup(8) = 1  ! final f4bar 
* parent's lines
          mothup(1,3)=1  ! final Z1
          mothup(2,3)=2  !
          mothup(1,4)=1  ! final Z2
          mothup(2,4)=2 
        mothup(1,5)=3   ! final f3
        mothup(2,5)=3   ! 
        mothup(1,6)=3   ! final f3bar
        mothup(2,6)=3   ! 
        mothup(1,7)=4   ! final f4
        mothup(2,7)=4   ! 
        mothup(1,8)=4   ! final f4bar
        mothup(2,8)=4   ! 
* KF code
      idup(1) = 21
      idup(2) = 21
*
      idup(3) = 23 
      idup(4) = 23
*  color flow 
        ipar(50) = 300
            icolup(1,1) = ipar(50) 
            icolup(2,1) = ipar(50) + 1
            icolup(1,2) = icolup(2,1)
            icolup(2,2) = icolup(1,1)
        ipar(50) = ipar(50) + 1
*  showering
       Ires = 4                     ! Z-boson
        kv  = 23                    ! KF code of Z-boson 
        call Res_branch(ires, kv, idz)
        if3 = FID(ires,idz,1)
        idup(5) =  if3        
        idup(6) = -if3        

        call Res_branch(ires, kv, idz)
        if4 = FID(ires,idz,1)
        idup(7) =  if4        
        idup(8) = -if4        
      
       NUP = 8
      if(abs(if3).le.6) then ! quarks
        ipar(50) = ipar(50) + 1
            icolup(1,5) = ipar(50) 
            icolup(2,6) = ipar(50) 
      endif
      if(abs(if4).le.6) then ! quarks
        ipar(50) = ipar(50) + 1
            icolup(1,7) = ipar(50) 
            icolup(2,8) = ipar(50) 
      endif
       call dec_zz4f(if3,if4)
      return
      end
