*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  10.09.2002                                  *
*   H+ H- production                                                         *
*   TopReX code = 31                                                         *
      subroutine COLORF_61(ip1, ip2)
*     -------------------------------                                        *
      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
*..................TopReX commons and internal variables
      Integer I, ip1, ip2
*...END VARIABLE'S DEFINITION

*............................................................................*
*     q [1] ---------O=======> H+ [3]                                        *
*                    <                                                       *
*                    >                                                       *
*                    <                                                       *
*     q_[2] ---------O=======> H- [4]                                        *
*............................................................................*

* PYUPR :        1   2     3   4  
*
*      nup = 4 ! q   q~ -> H+  H- 
* how PYTHIA will be treated
        istup(3) = 2  ! final H+ 
        istup(4) = 2  ! final H- 
* parent's lines
          mothup(1,3)=1  ! final H+
          mothup(2,3)=2  !
          mothup(1,4)=1  ! final H-
          mothup(2,4)=2  ! final H-
* KF code
      idup(3) =  37 
      idup(4) = -37
*
      idup(1) = ip1 
      idup(2) = ip2
*  color flow 
        ipar(50) = 300
         if(idup(1).gt.0) then
            icolup(1,1) = ipar(50) + 1 
            icolup(2,2) = icolup(1,1)
         elseif(idup(1).lt.0) then
            icolup(2,1) = ipar(50) + 1 
            icolup(1,2) = icolup(2,1)
         endif
*  showering
       do i = 3, nup
        if(abs(idup(i)).eq.37) call HPM_decay(I, idup(I)) 
       enddo 
      return
      end
