*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky,     10.09.2002                              *
*  H+- -> bbar T (-> b W -> f1 f2)
*   color flow and showering description for PYTHIA                          *
*............................................................................*
      subroutine COLORF_HFF_11(kp) 
*     -------------------------------                                        *
*............................................................................*
      implicit none
* PYTHIA6.2 common block for external user's process 
      include "hepeup.inc"
      include "txpar.inc" 
      integer mxdc
      parameter (mxdc=20)   
      integer ndec, kdec
      double precision pdm, pdpl
      common /decmom/ pdm(mxdc,5), pdpl(mxdc,4), ndec, kdec(mxdc,3)
      integer kp, izn, nbar1, nt, nw, nb1, nl1, nl2, fc1, fc2
*
       Nbar1 = NUP + 1
       NT    = NUP + 2
       NB1   = NUP + 3
       NW    = NUP + 4
       NL1   = NUP + 5                       ! U(nu) 
       NL2   = NUP + 6                       ! D(l+-)
       izn = idup(kp) / abs(idup(kp))        ! +1(-1) for H+ (H-)

        istup(nbar1) = 1           ! Bbar from H+- 
        idup(nbar1) = kdec(1,1) 
        mothup(1,nbar1) = kp 
        mothup(2,nbar1) = kp 
        ipar(50) = ipar(50) + 100
        icolup(1,nbar1) = (ipar(50) + 1) * (1 - izn)/2
        icolup(2,nbar1) = (ipar(50) + 1) * (1 + izn)/2
* 
        istup(nt) = 2           ! top from H+- 
        idup(nt) = kdec(2,1) 
        mothup(1,nt) = kp 
        mothup(2,nt) = kp 
        icolup(1,nt) = (ipar(50) + 1) * (1 + izn)/2
        icolup(2,nt) = (ipar(50) + 1) * (1 - izn)/2
* 
        istup(nb1) = 1           ! final b from top
        idup(nb1) = kdec(3,1) 
        mothup(1, nb1) = nt 
        mothup(2, nb1) = nt 
        icolup(1,nb1) = icolup(1, nt)
        icolup(2,nb1) = icolup(2, nt)
*
        istup(nw) = 2           ! final W from top
        idup(nw) = kdec(4,1)
        mothup(1,nw) = nt 
        mothup(2,nw) = nt 
*
       fc1 = kdec(5,1)                   ! KF code
       fc2 = kdec(6,1)                   ! KF code
       NUP = NUP + 6
       call colorf_BFF(NW, NL1, fc1, NL2, fc2)
*
       call DECHEP(KP, 1, nbar1) 
       call DECHEP(KP, 2, nt) 
       call DECHEP(KP, 3, nb1) 
       call DECHEP(KP, 4, nw) 
       call DECHEP(KP, 5, nl1) 
       call DECHEP(KP, 6, nl2) 

*      do I = 1,5
*       pup(i, nbar1) = pdm(1,I)      
*       pup(i, nt)    = pdm(2,I)      
*       pup(i, nb1)   = pdm(3,I)      
*       pup(i, nw)    = pdm(4,I)      
*       pup(i, nl1)   = pdm(5,I)      
*       pup(i, nl2)   = pdm(6,I)      
*      enddo
      RETURN
      END
