*----------------------------------------------------------------------------*
      FUNCTION CRBOX(S,T,U,EH2,EQ2)
      IMPLICIT REAL*8(A-H,O-Z)
      double COMPLEX CRBOX 
      COMPLEX*16 CI2,EPS,RM1,CPT2,SP
      COMMON/EMCUT/EMCUT2,PIE,RM1
      COMMON/SMALL/EPS
      IF(EQ2.GT.EMCUT2)THEN
      A=S/(U*T-EH2*EH2)
      ROOT=DSQRT((U*T-EH2*EH2)**2+4.D0*S*EQ2*(U*T-EH2*EH2))
      XP=((U*T-EH2*EH2)+ROOT)/2.D0/(U*T-EH2*EH2)
      XM=1.D0-XP
      CRBOX=2.D0/ROOT*(2.D0*CI2(EQ2,EH2,XP)-CI2(EQ2,U,XP)-CI2(EQ2,T,XP)
     1 +DLOG(-XM/XP)*(2.D0*CDLOG(EQ2+EPS-EH2*XP*XM)
     2 -CDLOG(EQ2+EPS-U*XP*XM)-CDLOG(EQ2+EPS-T*XP*XM)))
      ELSEIF(EQ2.LE.EMCUT2)THEN
      PT2=(U*T-EH2**2)/S
      CPT2=PT2
      CRBOX=2.D0/S/PT2*(-2.D0*SP(-CPT2/EH2)+SP(-CPT2/U)+SP(-CPT2/T)
     1 -2.D0*DLOG(EQ2/EH2)*DLOG((PT2+EH2)/EH2)
     2 +1.D0*DLOG(-EQ2/U)*DLOG((PT2+U)/U)
     3 +1.D0*DLOG(-EQ2/T)*DLOG((PT2+T)/T)
     4 -2.D0*RM1*PIE*(DLOG(EQ2/PT2)+DLOG((PT2+EH2)/EH2)))
      ENDIF
      RETURN
      END
