*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  17/02/2005                                  *
*   Z Z --> f3 f3bar   f4 f4bar  decays                                      *
*   TopReX code = 24                                                         *
      subroutine dec_ZZ4f(if3,if4)
      implicit none 
      include "txpar.inc" 
      double complex MEX(-1:1,-1:1,-1:1,-1:1)
      double precision coef, WTS0
      common /ggmex/ coef, WTS0, MEX
      include "hepeup.inc"
      double precision Pus
      common /user_mom/Pus(20,5)
      double precision l3p,   l3m,   l4p,   l4m
      common /zzlep/   l3p(5),l3m(5),l4p(5),l4m(5)
      double complex e3(-1:1,4), e4(-1:1,4) 
      common /zbospol/ e3, e4
      double complex LTZ3(-1:1,-1:1), LTZ4(-1:1,-1:1), 
     &  LTR30, LTR40
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      integer if3, if4
      double precision WTSF, RTS, rtsmax, PYR, ARAN
      data rtsmax /2.d0/
      save rtsmax
      double precision ps1,   ps2,   ps3,   ps4,   qq
      common /zzmom/   ps1(5),ps2(5),ps3(5),ps4(5),QQ(5)
      integer j1,j2,j3,j4, j31, j41
      double precision ps(5)
*
   
 1000 continue
      call LEPTEN(if3, ps3, e3, l3p, l3m, LTR30, LTZ3)
      call LEPTEN(if4, ps4, e4, l4p, l4m, LTR40, LTZ4)
      WTSF = 0.d0
       do 81 J1 = 1,1
       do 81 J2 = 1,2
       do 81 J3 = -1,1
       do 81 J31= -1,1
       do 81 J4 = -1,1
       do 81 J41= -1,1
 81    WTSF = WTSF 
     & + MEX(+1,(-3+2*j2),j3,j4)*conjg(MEX(+1,(-3+2*j2),j31,j41))
     & * LTZ3(j31,j3) * LTZ4(j41,j4)
      WTSF = wtsF * coef * Rpar(16)**2 
      RTS  = WTSF / (LTR30 * LTR40 * WTS0)
*
      IF(ipar(33).eq.1) THEN ! take into account spin correlations
*       if(rtsmax.lt.0.d0) rtsmax = rts
       if(rts.gt.rtsmax) rtsmax = rts
       if(rtsmax.ge.4.d0) then
         print*,'WARNING ZZ rat ',rtsmax
         rtsmax = 4.d0 
       endif       
       ARAN = pyr(0) * rtsmax  ! * 4.d0
       if(RTS.lt.aran) goto 1000
      ENDIF
* fill fermion momenta
      call Lorenb_s(qq, l3p, ps)
       do j1 = 1,5
        pus(5,j1) = ps(j1)        ! L- from Z1
        pup(J1,5) = ps(j1)
         enddo
      call Lorenb_s(qq, l3m, ps)
       do j1 = 1,5
        pus(6,j1) = ps(j1)        ! L+ from Z1
        pup(J1,6) = ps(j1)
         enddo
      call Lorenb_s(qq, l4p, ps)
       do j1 = 1,5
        pus(7,j1) = ps(j1)        ! L- from Z2
        pup(J1,7) = ps(j1)
         enddo
      call Lorenb_s(qq, l4m, ps)
       do j1 = 1,5
        pus(8,j1) = ps(j1)        ! L+ from Z2
        pup(J1,8) = ps(j1)
         enddo
      return
      end
