*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  26.01.2001                                  *
*     W Q Qbar production                                                    *
*     TopReX code = 5                                                        *
*............................................................................*
      subroutine gejzer_05(NFP)
      implicit None
      include "txpar.inc" 
      include "txpro.inc" 
      Integer NFP          ! number of particles in hard process 
      double precision Pus
      common /user_mom/Pus(20,5)
      double precision CKM2
      common /CKMD/ CKM2(-6:6,-6:6)

      double precision b1(5), b2(5), Pl(5), Pn(5)
      double precision q1(5), q2(5), qq(5)
      double precision            sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      Integer L, I, j1,j2
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision  x1, x2, sg, sgs
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6

      double precision pdfbt(-5:5, -5:5)
      double precision Veslum, Ves3, VesUD, VesDU
      double precision Parl(3), masstwo   
      logical first 
      data first /.TRUE./
      save first
* 

      IF(first) THEN
       first = .false.
        print*,'                          '
        print*,'*************',' WQQ production'
        call MQQLIM   !  check M(QQ)_min/max
        print*,'*************',' WQQ production'
      ENDIF

        do j1 = -6,6
        do j2 = -6,6
         xcs(j1,j2) = 0.d0
        enddo
        enddo
*
        do j1 = 1,5
         q1(j1) = 0.d0
         q2(j1) = 0.d0
        enddo
*
       parL(1) = Rpar(41) + Rpar(77) 
       parL(2) = Rpar(1) 
       parL(3) = Rpar(1)
        NXev(ipar(1)) = NXev(ipar(1)) - 1
 1001  call X1X2GEN(ParL, X1, X2, Veslum, q1, q2, QQ)
       NXev(ipar(1)) = NXev(ipar(1)) + 1
       call Mass2(q1, q2, sg, sgs)
       b1(5) = mq(Ipar(7))
       b2(5) = mq(Ipar(7))
       call rlip43(qq, b1, b2, PL, Pn, ves3)
       if(masstwo(b1,b2).LT.rpar(77).OR.
     &    masstwo(b1,b2).GT.Rpar(78)) then
*         print*,' mass b1 b2 ',masstwo(b1,b2)
         goto 1001
       endif
      Rpar(76) = (PL(1)+PN(1))**2 + (PL(2)+PN(2))**2 ! PT(W)^2
      Rpar(75) = dsqrt(Rpar(76)) 

      call TXQscale  ! Q-scale for PDF( Rpar(3)) and for alpha_s 
      call pdf_BT(x1, x2, pdfbt)
      
      NFP = 7
       do i = 1,5
          pus(1,i)=q1(i)
          pus(2,i)=q2(i)
          pus(3,i)=PL(i) + PN(i)    ! final (virtula) W*
          pus(4,i)=PN(i)
          pus(5,i)=PL(i)
          pus(6,i)=b1(i)            ! B
          pus(7,i)=b2(i)            ! Bbar
       enddo

      call MwQQ(q1, q2, b1, b2, PL, Pn, vesud)
      call MwQQ(q2, q1, b1, b2, PL, Pn, vesdu)
      VesUd = Veslum * vesud * ves3 * pi2_4 / (2.* sg)
      VesDu = Veslum * vesdu * ves3 * pi2_4 / (2.* sg)
* W+
      xcs( 2,-1)=VesUd * CKM2(2,1) * pdfBT( 2,-1) 
      xcs( 2,-3)=VesUd * CKM2(2,3) * pdfBT( 2,-3)
      xcs( 4,-1)=VesUd * CKM2(4,1) * pdfBT( 4,-1)
      xcs( 4,-3)=VesUd * CKM2(4,3) * pdfBT( 4,-3)
      xcs(-1, 2)=VesDu * CKM2(1,2) * pdfBT(-1, 2)
      xcs(-3, 2)=VesDu * CKM2(3,2) * pdfBT(-3, 2)
      xcs(-1, 4)=VesDu * CKM2(1,4) * pdfBT(-1, 4)
      xcs(-3, 4)=VesDu * CKM2(3,4) * pdfBT(-3, 4)
* W-
      xcs(-2, 1)=VesUd * CKM2(2,1) * pdfBT(-2, 1)
      xcs(-2, 3)=VesUd * CKM2(2,3) * pdfBT(-2, 3)
      xcs(-4, 1)=VesUd * CKM2(4,1) * pdfBT(-4, 1)
      xcs(-4, 3)=VesUd * CKM2(4,3) * pdfBT(-4, 3)
      xcs( 1,-2)=VesDu * CKM2(1,2) * pdfBT( 1,-2)
      xcs( 3,-2)=VesDu * CKM2(3,2) * pdfBT( 3,-2)
      xcs( 1,-4)=VesDu * CKM2(1,4) * pdfBT( 1,-4)
      xcs( 3,-4)=VesDu * CKM2(3,4) * pdfBT( 3,-4)

* BRS(i,2),   I= 1 : single W+,   2 : single W- production  
      sigrx=0.d0
      do i = -5,5 
        do l = -5,5 
         if(i.eq.2.or.i.eq.4.or.L.eq.2.or.L.eq.4) then
           xcs(i,l) = xcs(i,l) * BRS(1,2)  ! W+
         else
           xcs(i,l) = xcs(i,l) * BRS(2,2)  ! W-
         endif        
           sigrx=sigrx + xcs(i, l)
        enddo
      enddo
*
      return
      end
