*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  30.01.2005                                  *
*   gg -> box -> Z Z                                                         *
*   TopReX code = 24                                                         *
*............................................................................*
      subroutine gejzer_24(NFP) 
      Implicit None
      include "txpar.inc" 
      include "txpro.inc" 
      Integer NFP          ! number of particles in hard process 
      double precision Pus
      common /user_mom/Pus(20,5)
      double precision q1(5), q2(5)        
      double precision p3(5), p4(5), qq(5)
      double precision mq, mq2
      common/massql/ mq(0:20), mq2(0:20)
      double precision x1, x2, sg, sgs 

      double precision           sigrx, xcs
      common/xsecs/sigrx,xcs(-6:6,-6:6)
      double precision vlum, vesr, vesm, Parl(3), PT 
      double precision pdfBT(-5:5, -5:5)
      integer i, j1,j2
      double precision  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst / pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      LOGICAL first
      DATA first /.TRUE./
      SAVE first
****
      IF(first) THEN
       if(Ipar(17).eq.2) then  
          Ipar(17) = 0   ! normal case
       else 
          Ipar(17) = 1   ! if sigRX> sigMX events is NOT accepted 
       endif             ! and  sigRX is NOT added to Xsig
*
       first = .false.
       if(Rpar(103).gt.Rpar(67)) Rpar(67) = Rpar(103) ! min PT(Z)
       print*,' PT(Z)min = ',Rpar(67)
      ENDIF
* 
        do j1 = -6,6
        do j2 = -6,6
         xcs(j1,j2) = 0.d0
        enddo
        enddo
      call zer5mom(q1) 
      call zer5mom(q2) 
      call zer5mom(p3) 
      call zer5mom(p4) 
*
       Parl(1) = 2.d0*dsqrt(rpar(46) + rpar(67)**2) 
       Parl(2) = Rpar(1)
       Parl(3) = Rpar(1)

      NXev(ipar(1)) = NXev(ipar(1)) - 1
 295  continue 
      call X1X2GEN( Parl, X1, X2, Vlum, q1, q2, QQ)
      NXev(ipar(1)) = NXev(ipar(1)) + 1
      call mass2(q1, q2, sg, sgs)
      call pdf_BT(x1, x2, pdfbt)

      p3(5) = rpar(45)
      p4(5) = rpar(45)
      call LIPS2(QQ, p3, p4, vesr) 
      if(PT(p3).lt.Rpar(67)) goto 295

      Rpar(75) = PT(p3)
      Rpar(76) = Rpar(75)**2

      call TXQscale   !  setting Q-scale for PDF( Rpar(3)) and for alpha_s  

       call GGZZ(q1, q2, p3, p4, vesm)
       vesM = Vlum * VesR * VesM * pi2_4 / (2.* sg)
       xcs(0,0) = pdfBT( 0, 0) * Vesm 

      sigrx=xcs(0,0)
      NFP = 4
      if(ipar(8).ne.+1) return 

       do i=1,5
         pus(1,i) = q1(i)
         pus(2,i) = q2(i)
         pus(3,i) = p3(i)           ! Z-boson 
         pus(4,i) = p4(i)           ! Z-boson
        enddo
      return
      end
