*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  25.11.2003                                  *
      double precision FUNCTION massTWO(p1, p2) 
*     -------------------------------                                        *
*                                                                            *
*    invariant mass of two 4-vectors                                         *
*    input : p1 and p2                                                       *
*    sm  - mass, if SM2 < 0, then SM = -sqrt(-sm2)                           *
*............................................................................*

      Implicit none
      double precision p1(5), p2(5) 
*
      masstwo = (p1(4) + p2(4))**2
     &   - (p1(1) + p2(1))**2
     &   - (p1(2) + p2(2))**2
     &   - (p1(3) + p2(3))**2
      if(masstwo.ge.0d0) then
        masstwo =  DSQRT(masstwo)
      else
        masstwo = -DSQRT(-masstwo)
      endif
      return
      end
