
*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  20.11.2004                                  *
*   M(f fbar) min/max for  Z Q Qbar production                               *
*............................................................................*
      subroutine MFFLIM
      implicit None
      include "txpar.inc" 
      integer LD, LU
*
      Ld = 1
*     
      if(Rpar(79).eq.-1.d0) then
         Rpar(79) = Rpar(70)
         Ld = 0
      elseif(Rpar(79).ge.Rpar(1)) then
         Ld = -1
          print*,' user value of min(M(ff))',rpar(79),
     &' is outside kinematic limits - stop'           
         STOP
      elseif(Rpar(79).gt.0.d0.AND.Rpar(79).lt.rpar(70)) then
           print*,' M(ff)-min ',rpar(79),
     &' is too low. Rpar(70)) ',Rpar(70),' will be used'
           rpar(79) = Rpar(70) 
         Ld = 0
      endif 
*  check max M(QQ)
      Lu = 1
      if(Rpar(80).eq.-1.d0) then
         Lu = 0
         Rpar(80) = Rpar(1)
      elseif(Rpar(80).ge.Rpar(1)) then
         Lu = 0
        print*,' M(ff)-max ',rpar(80),
     &' is greater then sqrt(s). Value from LIPS will be used'
          Rpar(80) = Rpar(1)
      elseif(Rpar(80).gt.0.d0.AND.Rpar(80).le.rpar(79)) then
        Lu = -1 
        print*,' M(ff)-max',rpar(80),
     &' less then M(ff)-min ',rpar(79),' stop'           
           STOP
       endif
**
       if(Ld.eq.0) then 
        print*,' default M(ff)-min = ',rpar(79)
       elseif(Ld.eq.1) then 
         print*,' M(ff)-min = ',rpar(79)
       else
        STOP
       endif
       if(Lu.eq.0)  then
         print*,' M(ff)-max from LIPS'
       elseif(Lu.eq.1) then
         print*,' M(ff)-max = ',rpar(80)
       else
        STOP
       endif
      RETURN
      end
