
*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  24/06/2000                                  *
      subroutine pdf_BT(x1, x2,  pdfbt)
*     -------------------------------------------                            *
* returns the product of x1*f_B(x1) * x2*f_T(x2)                             *
* 0      1    2    3    4    5    6                                          *
* gluon  d    u    s    c    b    t                                          *
*       -1   -2   -3   -4   -5   -6                                          *
*       dbar ubar sbar cbar bbar tbar                                        *
*............................................................................*
      Implicit none
      include "txpar.inc" 
      double precision x1, x2
      Integer IB, IT 
      double precision pdfb(-5:5), pdfBT(-5:5,-5:5)
* PYTHIA 6... 
      double precision Q2
      INTEGER MINT
      double precision VINT
      COMMON/PYINT1/MINT(400),VINT(400)
      double precision dxpdf(-25:25)
*....
*      Q2 = qqsf*qqsf 
      Q2 = Rpar(3)**2 
* PYTHIA 6...       !         call PyPDFU (Iprot, x2, Q2, dxpdf)
*.. Mint(11)=Beam, Mint(12)=Target particle      
*.. target
      CALL PYPDFU(MINT(11), x1, Q2, dxpdf)
      do IB = -5, 5 
       pdfB(IB)  = dxpdf(IB)
      enddo
c  beam
      CALL PYPDFU(MINT(12), x2, Q2, dxpdf)
      do IB = -5, 5
       do IT = -5, 5
        pdfBT(IB, IT)  = pdfB(IB) * dxpdf(IT)
       enddo
      enddo
      return
      end
