*----------------------------------------------------------------------------*
* product of three complex matrices,  V = A1 * A2 * A3
      subroutine PROD_3(A1, A2, A3, v) 
*     ------------------------------                                         *
      implicit none
      double complex A1(4,4), A2(4,4), A3(4,4), u(4,4), v(4,4) 
      integer i1, i2, k 
*
      do i1 = 1,4
       do i2 = 1,4
        u(i1,i2) = (0.d0, 0.d0)
         do k=1,4
          u(i1,i2) = u(i1,i2) + A1(i1,k) * A2(k,i2)
         enddo
       enddo
      enddo

      do i1 = 1,4
       do i2 = 1,4
        v(i1,i2) = (0.d0,0.d0)
          do k = 1,4
           v(i1,i2) = v(i1,i2) + U(i1,k)*A3(k,i2)
          enddo
       enddo
      enddo
      RETURN
      END
