*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  25.06.2004                                  *
      subroutine Rlip44(R, k1, k2, k3, wtR)
*     -------------------------------------------                            *
*  calculates dLIPS3 with denominator                                        *
*  R -> pZ(f1, f2) f3                                                        *
*  ONE denominator is  included                                              *
*  the denominator is (pZ^2-M_Z^2)^2 + (M_Z * Width_Z)^2  due to Z-boson     *
*............................................................................*
      implicit none
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst/ pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision R(5), k1(5), k2(5), k3(5), pz(5)
      include "txpar.inc" 
      double precision plim(2), ves, p2s, wtR
      plim(1) = rpar(70)
      plim(2) = R(5)-2.*k1(5)
      call brtwig(plim, rpar(45), rpar(48), ves, p2s)
       pz(5) = p2s
      call Lips2(R,  pz, k3, wtR)
      wtR = wtR * ves
      call Lips2(pz, k1, k2, ves)
      wtR = pi2_3 * wtR * ves 
      wtR = wtR * ( (rpar(46) - p2s**2)**2 + Rpar(48)**2)
      return
      end
