*----------------------------------------------------------------------------*
*.. author : Serge Slabospitsky   10.03.2002                                 *
*.... TOP decay intp b~ H+-, H+- -> t* (-> b W* => b f1 f2) + bbar           *
      subroutine THBTS_dec(gamh, gamt, gtot) 
*     --------------------------------------                                 *
* T(R) -> B(k2) H*(ph) (-> Bbar(q11) T*(p1) (-> B(k1) W*(pw) nu(l1) l+-(l2)  *
*............................................................................*

      implicit none
      include "txpar.inc" 
      double precision mq, mq2
      common/massql/   mq(0:20), mq2(0:20)
      double precision CKM2
      common /CKMD/    CKM2(-6:6,-6:6)
      double precision HCPL,       HCPL2   
      common/HPMCPL/   HCPL(-20:20), HCPL2(-20:20)
*...........
      double precision p2(5),k2(5),ph(5),k1(5),q1(5),l1(5),l2(5)
      double precision Ves, coef, Vs1, AT1, AT2, scalp
      double precision pmm(2), p2s, gamh, gamt, gtot , dh(3), vesm
      integer I, id 
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
* 
        Gtot = 0.d0
   
      coef = rpar(26)**2 / 2.d0
      coef = coef * pi2_3
      coef = coef * pi2_4 / 2.d0 / mq(6) 
      AT1 = hcpl2(6) + hcpl2(5) 
      AT2 = 2.d0 * mq(5)*mq(6)*hcpl(5)*hcpl(6)

      p2(5) = mq(6)
      p2(4) = p2(5)
      p2(3) = 0.d0
      p2(2) = 0.d0
      p2(1) = 0.d0
      k2(5) = mq(5)  
      pmm(1) = rpar(70) + 2.d0*mq(5)
      pmm(2) = mq(6) - mq(5)


      do 225 id = 1,mid(0, 2) 
       if(mid(id, 2).le.-1) goto 225

      DO i = 1,ipar(53)
      call brtwig(pmm, rpar(51), gamh, VS1, p2s)
       ves = coef * VS1 
       ph(5) = p2s
      call LIPS2 (p2, k2, ph,  VS1) 
       ves = ves * VS1 
       call HPM_ME_03(id, ph, k1, q1, l1, l2, dh, vesm) 
       vesm = vesm * (at1*scalp(p2,k2) + at2)
      Gtot = Gtot + ves * vesm
      ENDDO
 225  continue

      Gtot = Gtot / ipar(53) 

      return
      end
