*----------------------------------------------------------------------------*
      subroutine TRANS_CPL(IT, IQ, ANL, ANR, CR, CL) 
      implicit none
      include "txpar.inc" 
      double precision pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common/piconst/  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      double precision ANL(2,20), ANR(2, 20)
      double complex   CR, CL, U
      double complex  ei   
      data ei/(0.d0, 1.d0)/
      integer IT, IQ
*
      CR = (0.d0, 0.d0)
      CL = (0.d0, 0.d0)
      If    (it.eq.1.or.it.eq.11) then
        CL = ANL(1,iq) + ei*ANL(2,iq)  ! Left or  'f'
        CR = ANR(1,iq) + ei*ANR(2,iq)  ! right or 'h'
      ElseIf(it.eq.2.or.it.eq.4) then
        CL = 
     & dabs(ANL(1,iq))*(dcos(ANL(2,iq)) + ei*dsin(ANL(2,iq)))
        CR = 
     & dabs(ANR(1,iq))*(dcos(ANR(2,iq)) + ei*dsin(ANR(2,iq)))
      ElseIf(it.eq.3) then !  phase in PI
        CL = dabs(ANL(1,iq))*dcos(pi*ANL(2,iq))
     &  + ei*dabs(ANL(1,iq))*dsin(pi*ANL(2,iq))
        CR = dabs(ANR(1,iq))*dcos(pi*ANR(2,iq))
     &  + ei*dabs(ANR(1,iq))*dsin(pi*ANR(2,iq))
      EndIf
*
        If(it.eq.11.or.it.eq.12.or.it.eq.13.
     &  or.it.eq.4) then
           U = CL
           CL = U - CR ! f - h
           CR = U + CR ! f + h
        EndIf
      return
      end     
