*----------------------------------------------------------------------------*
* author: Serge Slabospitsky,  08.06.2006                                    *
* evaluate X-sections values, max(diff. X-section)                           *
* . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . .*
      subroutine TX_EST
*     ----------------------
      implicit none 
      include "txpar.inc" 
      include "txpro.inc" 
      include "pydat_62.inc"
C...User process event common block 
      INTEGER MAXPUP
      PARAMETER (MAXPUP=100)
      INTEGER IDBMUP,PDFGUP,PDFSUP,IDWTUP,NPRUP,LPRUP
      double precision EBMUP,XSECUP,XERRUP,XMAXUP
      COMMON/HEPRUP/IDBMUP(2),EBMUP(2),PDFGUP(2),PDFSUP(2),
     &IDWTUP,NPRUP,XSECUP(MAXPUP),XERRUP(MAXPUP),XMAXUP(MAXPUP),
     &LPRUP(MAXPUP)
*
* rxsig(I,1) : sum of differential X-section   
* rxsig(I,2) : total X-section value
* rxsig(I,3) : max of differential X-section 
* rxsig(I,4) : sum of differential X-section squared
      double precision sigpb, xcspb(-6:6,-6:6)
      common/xsecpb/   sigpb, xcspb
      double precision deltasig, delpdf 
      integer Ncall, Nups, Icur, J   
      double precision nsng1, nsng2
      common /xmatch/nsng1(2), nsng2(2)
*........................................      
*
       Ipar(8) = -1  ! init flag
*       Sigev  = 0.d0

* start through all switched-ON rpocesses
        Ncall = 0
         Ipar(100) = Ipar(1)
         Icur = Ipar(100)
*         if(Ipar(18).eq.1) call PDFEST(-1, delpdf)
 1000   NXev(icur) = NXev(icur) + 1
        Ncall = Ncall + 1
        if(Ncall.gt.Ipar(51)) goto 1001
         call TX_GEJZER(NUPS)   

       if(sigpb.gt.RXsig(icur,3)) then
         RXsig(Icur,3) = sigpb
       endif      
*
          RXsig(Icur, 1) = RXsig(Icur, 1) + sigpb
          RXsig(Icur, 4) = RXsig(Icur, 4) + sigpb**2
         goto 1000 
 1001  continue
        NXev(icur) = NXev(icur) - 1
         RXsig(icur,2) = RXsig(icur,1) / NXev(icur)
*** TopReX matching
        if    (txsel.eq.1) then 
          RXsig(1,2) = RXsig(1,1) / NXev(1) 
          RXsig(2,2) = RXsig(2,1) / NXev(2) 
        elseif(txsel.eq.2) then 
          do j = 30,33
            RXsig(J,2) = RXsig(J,1) / NXev(J) 
          enddo
        endif
***
        RXsig(icur, 4) = RXsig(icur,4) /  NXev(icur) 
        deltasig = 
     &dsqrt((RXsig(icur,4) - RXsig(icur,2)**2)/NXev(icur)) 
*          if(Ipar(18).eq.1.and.Ipar(19).eq.2) call PDFEST(1, deltasig) 
        write(*,4117)
 4117   format(/,50('*'),/,'*')
        call tx_nam(1)
        if(ipar(18).eq.1) then
         write(*,4112) NXev(Ipar(1)),RXsig(icur,2), deltasig, delpdf 
 4112   format('* TopReX: Nev = ',i10,/,
     & '* sigma(pb)   = ',1p,d11.4,' +- ',1p,d11.4,' +- ',
     &  1p,d11.4,' (PDF)')
         else
        write(*,4116) NXev(Ipar(1)),RXsig(Ipar(1),2), deltasig
 4116   format('* TopReX: Nev = ',i10,/,
     & '* sigma(pb) = ',1p,d11.4,' +- ',1p,d11.4)
        endif
        write(*,4115)
 4115   format('*',/,50('*'))
        

      if(RXsig(icur,2).le.0.d0) then
        write(*,4555) 
 4555 format(/,2x,'TopReX : zero or negative cross section. Stop')
           STOP
      endif        
*        sigev = xsec2     ! sig_max = sigma_tot !
        xsecup(Ipar(101)) = RXsig(icur,2) ! 
        xmaxup(Ipar(101)) = RXsig(icur,2)  ! sigmx !* 10.**9
* TopReX matching
       if    (txsel.eq.1) then 
          do j = 1,2
            xsecup(j) =  RXsig(j,2) 
            xmaxup(j) = xsecup(j) 
          enddo
       elseif(txsel.eq.2) then 
          do j = 30,33
            xsecup(j) =  RXsig(j,2) 
            xmaxup(j) = xsecup(j) 
          enddo
       endif
      RETURN
      END
