c----------------------------------------------------------------------------c
      subroutine TX_NAM(mode) 
      implicit none
      include "txpar.inc"
      include "txpro.inc" 
      character*12  FRAME, BEAM, TARGET
      common /TXFBT/FRAME, BEAM, TARGET
      character *40 np(0:200)     ! process's name 
      character *40 procnum            ! process's name 
      character *40 mtop(0:1)         ! t-mass generation
      integer spinum
      common /maxspinum/ spinum
      data spinum /7/
      save /maxspinum/
      character *40 spin(0:7)         ! spin correlations
      character *40 boxhig(0:2)         ! spin correlations
      character*20 whr0 
      data whr0 /'   TopReX process  '/ 
      integer ITZ, mode
      logical first
      data first /.TRUE./
      save first
*
*             123456789012345678901234567890
*             12345678901234567890123456789|1234567890
****
      if(first) THEN
      first=.FALSE.
      np(1) =' EW top : W g (2->2)                    '  ! Ipar(1) =  1
      np(2) =' EW top : W g (2->3)                    '  ! Ipar(1) =  2
      np(3) =' EW top : t W                           '  ! Ipar(1) =  3
      np(4) =' EW top : W* -> t b~                    '  ! Ipar(1) =  4
      np(5) =' W Q Qbar                               '  ! Ipar(1) =  5
      np(6) =' W+-  -> tau nu                         '  ! Ipar(1) =  6
      np(7) =' W+- (-> tau nu)  JET                   '  ! Ipar(1) =  7
      np(8) =' H+-  -> t  bbar                        '  ! Ipar(1) =  8
      np(9) =' H+-  -> tau nu                         '  ! Ipar(1) =  9
      np(10)=' H+- (-> tau nu)  JET                   '  ! Ipar(1) = 10
      np(11)=' EW top : W g (2-> 2 + 3)               '  ! Ipar(1) = 11
      np(20)=' gg+qq~ -> tt~ Breit-Wig                '  ! Ipar(1) = 20
      np(21)=' gg     -> tt~ Breit-Wig                '  ! Ipar(1) = 21
      np(22)=' qq~    -> tt~ Breit-Wig                '  ! Ipar(1) = 22
      np(23)=' Z Q Qbar                               '  ! Ipar(1) = 23
      np(24)=' g g -> Z Z    with   Z -> f fbar       '  ! Ipar(1) = 24
      np(25)=' gg+qq~ -> t t~ gamma                   '  ! Ipar(1) = 25

      np(30)=' FCNC   g u(c) -> t -> b W              '  ! Ipar(1) = 30
      np(31)=' FCNC:  q q~ -> t u(c)~                 '  ! Ipar(1) = 31
      np(32)=' FCNC:  g g  -> t u(c)~                 '  ! Ipar(1) = 32
      np(33)=' FCNC:  g u/c  -> t g                   '  ! Ipar(1) = 33
      np(34)=' FCNC:  g u/c  -> t gamma (FCNC-GLUON   '  ! Ipar(1) = 34
*
      np(61)=' qq~    -> H+ H-                        '  ! Ipar(1) = 61
*
      np(99)=' for testing and development            '  ! Ipar(1) = 52
*      
        mtop(0)=' m(top) - fixed                         '  ! Ipar(31) = 0
        mtop(1)=' m(top) - Breit_Wigner(Gamma_tot)       '  ! Ipar(31) = 1

       call spin_check
        spin(0)=' NO spin correlations                   '  ! ipar(33) = 0
        spin(1)=' spin correlations is included          '  ! ipar(33) = 1
        spin(2)=' spin LEFT-state                        '  ! ipar(33) = 2
        spin(3)=' spin RIGHT-state                       '  ! ipar(33) = 3
        spin(4)=' T Tbar :  Left  Left                   '  ! ipar(33) = 4
        spin(5)=' T Tbar :  Left  Right                  '  ! ipar(33) = 5
        spin(6)=' T Tbar :  Right Left                   '  ! ipar(33) = 6
        spin(7)=' T Tbar :  Right Right                  '  ! ipar(33) = 7


      boxhig(0)=' BOX only                               '  ! Ipar(24) = 0
      boxhig(1)=' BOX and Higgs                          '  ! Ipar(24) = 1
      boxhig(2)=' Higgs only                             '  ! Ipar(24) = 2
*
*
       write(*,888) 
 888  format(//,3x,76('*'),//,
     &4x,'TopReX start to generate',/,
     &4x,'------------------------',/)
       if(ipar(1).eq.20.and.txpro(20).eq.1) then
          procnum = np(20)
          if(ipar(22).eq.1) procnum = np(21)
          if(ipar(22).eq.2) procnum = np(22)
      else 
         procnum = np(ipar(1))
       endif
       write(*,889) beam,target,Rpar(1)
 889  format(4x,a6,1x,a6,' collision  with Ecm = ',f8.1,' GeV',/)
*
      ENDIF
      if(mode.eq.0.and.txsel.eq.1.and.ipar(1).eq.2) return

      if( txpro(1) .eq.1.or.txpro(2). eq.1.
     & or.txpro(3) .eq.1.or.txpro(4) .eq.1.
     & or.txpro(5) .eq.1.or.txpro(6). eq.1.
     & or.txpro(7) .eq.1.or.txpro(8). eq.1.
     & or.txpro(9) .eq.1.or.txpro(10).eq.1.
     & or.txpro(20).eq.1.or.txpro(25).eq.1.
     & or.txpro(23).eq.1.or.txpro(24).eq.1.
     & or.txpro(30).eq.1.or.txpro(31).eq.1.
     & or.txpro(32).eq.1.or.txpro(33).eq.1.
     & or.txpro(34).eq.1.or.txpro(61).eq.1.
     & or.txpro(99).eq.1)  then
       continue 
      else
       write(*,890) Ipar(1)  
 890   format(//,3x,76('*'),////,
     &4x,'non-existed TopReX process <',i4,' >  STOP running')
       STOP
      endif

       if(ipar(1).eq.20.and.txpro(20).eq.1) then
          procnum = np(20)
          if(ipar(22).eq.1) procnum = np(21)
          if(ipar(22).eq.2) procnum = np(22)
      else 
         procnum = np(ipar(1))
      endif
*
      if(ipar(1).eq.5) then 
        if(ipar(7).eq.5) then
          procnum = ' W  B Bbar                   '  ! Ipar(1) = 5
        elseif(ipar(7).eq.4) then
         procnum = ' W  C Cbar                    '  ! Ipar(1) =  5
        endif
      endif
      if(ipar(1).eq.23) then 
        if(ipar(7).eq.5) then
         procnum = ' Z  B Bbar                              '! Ipar(1) = 5
        elseif(ipar(7).eq.4) then
         procnum = ' Z  C Cbar                              '! Ipar(1) = 5
        endif
      endif

      if(mode.eq.0.and.txsel.eq.1) procnum = np(11)
 2000 continue
        ITZ = 0
      if(Ipar(1).eq.1. or.Ipar(1).eq.2. or.Ipar(1).eq.3.
     .or.Ipar(1).eq.4. or.Ipar(1).eq.11.or.Ipar(1).eq.20.
     .or.Ipar(1).eq.25.
     .or.Ipar(1).eq.8) then
        ITZ = 1
      elseif(Ipar(1).eq.24) then
        ITZ = 2
      endif
      If(ITZ.eq.1) then
       if(mode.eq.0.and.txsel.eq.1) then
        write(*,989) whr0, procnum,mtop(Ipar(31)),
     & spin(ipar(33)) 
 989   format(1x,a20,1x,3x,1x,':',a40,/,3x,a40,/,3x,a40,/)
       else
        write(*,991) whr0,Ipar(1),procnum,mtop(Ipar(31)),
     & spin(ipar(33)) 
 991   format(1x,a20,1x,i3,1x,':',a40,/,3x,a40,/,3x,a40,/)
       endif


      ElseIf(ITZ.eq.2) then
       write(*,992) whr0,Ipar(1),procnum,
     &  boxhig(Ipar(24)), spin(ipar(33))
 992  format(1x,a20,1x,i3,1x,':',a40,/,3x,a40,/,3x,a40,/)
      Else
       write(*,998) whr0,Ipar(1),procnum
      EndIf
 998  format(1x,a20,1x,i3,1x,':',a40,/)
* 
      If(Ipar(1).eq.25) then
       if(ipar(22).eq.0)     then
          write(*,923) 
       elseif(ipar(22).eq.1) then 
          write(*,924) 
       elseif(ipar(22).eq.2) then 
          write(*,925) 
       else
          write(*,*) 'wrong Ipar(22) = ',Ipar(22),'stop'
          STOP
       endif
       EndIf




      If(Ipar(1).eq.23) then
       if(ipar(22).eq.0)     then
          write(*,920) 
       elseif(ipar(22).eq.1) then 
          write(*,921) 
       elseif(ipar(22).eq.2) then 
          write(*,922) 
       else
          write(*,*) 'wrong Ipar(22) = ',Ipar(22),'stop'
          STOP
       endif

       if(ipar(23).eq.0)     then
          write(*,930) 
       elseif(ipar(23).eq.1) then 
          write(*,931) 
       elseif(ipar(23).eq.2) then 
          write(*,932) 
       else
          write(*,*) 'wrong Ipar(23) = ',ipar(23),'stop'
          STOP
       endif
      Endif

 920   format('   gluon gluon  + q qbar -> Z Q Qbar')
 921   format('   gluon gluon  -> Z Q Qbar')
 922   format('   q qbar -> Z Q Qbar')
 930   format('   Z Q Qbar:  gamma* + Z* -> f fbar')
 931   format('   Z Q Qbar:  gamma* -> f fbar')
 932   format('   Z Q Qbar:  Z* -> f fbar')
 923   format('   gluon gluon  + q qbar -> t tbar gamma ')
 924   format('   gluon gluon  -> t tbar gamma ')
 925   format('   q qbar -> t tbar gamma ')
      return
      end
