
c----------------------------------------------------------------------------c
*-- Author :    N.Stepanov,       modified by S.Abdullin                     *
* modified by S.Slabospitsky                                                 *
*............................................................................*
      double precision FUNCTION TX_PHIFUN(P)
*...PHI  CALCULATIONS
      IMPLICIT NONE
      double precision EPSSQ 
      data epssq /0.000000000001d0/
      double precision P(5), PX, PY 
      double precision  pi, pi2, pi4, pi2_3, pi2_4, pi2_6
      common /piconst / pi, pi2, pi4, pi2_3, pi2_4, pi2_6
 
      IF(DABS(P(1)).LT.EPSSQ.AND.DABS(P(2)).LT.EPSSQ) THEN
         PRINT '(''PHIFUN : anomalous input : '',2(1PE13.5))',P(1),p(2) 
         IF(PY.GE.0.) THEN
            TX_PHIFUN = 0.5 * PI
          ELSE
            TX_PHIFUN = 1.5 * PI
         ENDIF
       ELSE
         Px = p(1)
         py = p(2)
         TX_PHIFUN = DATAN2(PY,PX)
      ENDIF
      IF(TX_PHIFUN.LT.0.) TX_PHIFUN = TX_PHIFUN + PI2
      END
