

*----------------------------------------------------------------------------*
*---  modified by Serge Slabospitsky 13.12.2004  ------------------------
*---  could be used with TopReX version >= 4.09  ------------------------
*------------------------------------------------------------------------ 
C...All partons at the end of the shower phase are stored in the
C...HEPEVT commonblock. The interesting information is
C...NHEP = the number of such partons, in entries 1 <= i <= NHEP,
C...IDHEP(I) = the particle ID code according to PDG conventions,
C...PHEP(J,I) = the (p_x, p_y, p_z, E, m) of the particle.
C...All ISTHEP entries are 1, while the rest is zeroed.
 
C...The user decision is to be conveyed by the IVETO value.
C...IVETO = 0 : retain current event and generate in full;
C...      = 1 : abort generation of current event and move to next.
 
      SUBROUTINE TX_UPVETO(IVETO)
      implicit none
      include "txpar.inc" 
      include "txpro.inc" 
      include "hepevt.inc" 
      integer IVETO
C...HEPEVT commonblock.
*      PARAMETER (NMXHEP=4000)
*      COMMON/HEPEVT/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
*     &JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
*      DOUBLE PRECISION PHEP,VHEP
*      SAVE /HEPEVT/
 
C...Next few lines allow you to see what info PYVETO extracted from
C...the full event record for the first two events.
C...Delete if you don't want it.
c      INTEGER NLIST/0/
c      SAVE NLIST
c      goto 999
c      IF(NLIST.LE.2) THEN
c        WRITE(*,*) ' Full event record at time of UPVETO call:'
c        CALL PYLIST(1)
c        WRITE(*,*) ' Part of event record made available to UPVETO:'
c        CALL PYLIST(5)
c        NLIST=NLIST+1
c      ENDIF
 
C...Make decision here.
      IVETO = 0
      if(txsel.eq.1.OR.txsel.eq.2) then ! for TopReX matching
       call txmatching(IVETO)             ! for   
       NHEP = 0 
      endif
      RETURN
      END
