*----------------------------------------------------------------------------*
*... author : Serge Slabospitsky                                             *
*... 17.12.2003                                                              *
*                                                                            *
      subroutine TXTQ2SMR(Q, p1, k1, k2, pp1, kk1, kk2)
*     -------------------------------------------------                      *
* smear mtop according Breit-Wigner and rescale T 5-momentum and 4-mom.(q)   *
      implicit none
      include "txpar.inc" 
      double precision q(5), p1(5),k1(5),k2(5), pp1(5),kk1(5), kk2(5)
      double precision ps(5), ps1(5), pk(5), scalp 
      double precision mt1, v0, v1, TopMV
      double precision mq, mq2
      common /massql/  mq(0:20), mq2(0:20)
      integer i, Nc
*
      do i = 1,4
       ps(I) = k1(I) + k2(I)
      enddo
      ps(5) = dsqrt(scalp(ps,ps))
      nc = 0
 101  mt1 = TopMV(Rpar(34), mq(6))
      nc = nc + 1
       if(nc.ge.100) then
         do i = 1,5
          pp1(I) = p1(I)
          kk1(I) = k1(I)
          kk2(I) = k2(I)
         enddo
        return
       endif
      if((mt1 + ps(5)).ge.Q(5)) goto 101
*
      call lorenf_s (Q, p1, kk1) ! kk1 is T momentum in TTbar rest frame
       v0 = dsqrt(kk1(4)**2 - mq2(6))
      kk1(5) = mt1
      kk1(4) = 0.5d0*(Q(5)**2+mt1**2 - ps(5)**2)/Q(5)
       v1 = dsqrt(kk1(4)**2 - mt1**2) / v0
         do i = 1,3
          kk1(I) = v1 * kk1(I)
         enddo
      call lorenb_s(q, kk1, pp1) 
*
       ps1(5) = ps(5)
         do i = 1,4
          ps1(I) = Q(I) - pp1(I)
         enddo
      call lorenf_s (ps,  k1, pk) ! kk1 is T momentum in TTbar rest frame
      call lorenb_s (ps1, pk, kk1) 
       kk2(5) = k2(5)
         do i = 1,4
          kk2(I) = Q(I) - pp1(I) - kk1(I)
         enddo
      return
      end
