*----------------------------------------------------------------------------*

*----------------------------------------------------------------------------*
*... author : Serge Slabospitsky                                             *
*... 16.12.2003                                                              *
*                                                                            *
      subroutine TXTTSMR(Q, p1, p2, pp1, pp2)
*     ---------------------------------------                                *
* smear mtop according Breit-Wigner and rescale T and Tbar 5-momenta         *
      implicit none
      include "txpar.inc" 
      double precision q(5), p1(5), p2(5), pp1(5), pp2(5)
      double precision mt1, mt2, v0, v1, TopMV
      double precision mq, mq2
      common /massql/  mq(0:20), mq2(0:20)
      integer i, Nc
*
      nc = 0
 101  mt1 = TopMV(Rpar(34), mq(6))
      mt2 = TopMV(Rpar(34), mq(6))
      nc = nc + 1
       if(nc.ge.100) then
         do i = 1,5
          pp1(I) = p1(I)
          pp2(I) = p2(I)
         enddo
        return
       endif
      if((mt1+mt2).ge.Q(5)) goto 101
*
      call lorenf_s (Q, p1, pp2) ! pp1 is defined in TTbar rest frame
       v0 = dsqrt(pp2(4)**2 - mq2(6))
      pp2(5) = mt1
      pp2(4) = 0.5d0*(Q(5)**2+mt1**2-mt2**2)/Q(5)
       v1 = dsqrt(pp2(4)**2 - mt1**2) / v0
         do i = 1,3
          pp2(I) = v1 * pp2(I)
         enddo
      call lorenb_s(q, pp2, pp1) 
*
      pp2(5) = mt2
         do i = 1,4
          pp2(I) = Q(I) - pp1(I)
         enddo
      return
      end
