
*----------------------------------------------------------------------------*
*.. author:  Serge Slabospitsky  30.05.2006                                  *
*  Ubar(p) gamma_nu (1/2)(1-gamma5) V(k), p^2 = k^2 = 0                      *
* return 4x4 matrix
      subroutine VbosMX(p, k, V)
*     ---------------------                                                  *
      implicit none
      double precision p(5), k(5), pp, pm, kp, km 
      double complex p1, p2,  k1, k2, Z
      double complex V(4,4), VP, VM, V1, V2
      double complex ei 
      data ei/(0.d0, 1.d0)/
      integer i1,i2
*
      do 123 i1 = 1,4
      do 123 i2 = 1,4
 123    V(i1,i2) = (0.d0, 0.d0)
       Pp = p(4) + p(3)   
       Pm = p(4) - p(3)   
       P1 = p(1) + ei * p(2)
       P2 = p(1) - ei * p(2)
*
       kp = k(4) + k(3)   
       km = k(4) - k(3)   
       k1 = k(1) + ei * k(2)
       k2 = k(1) - ei * k(2)
*
      If(    PP.ge.PM.AND.KP.ge.KM) then
        Z = 2.d0 / dsqrt(PP * KP)
       VP = pp * kp * Z
       VM = p1 * k2 * Z
       V1 = p1 * kp * Z
       V2 = pp * k2 * Z
      ElseIf(PP.ge.PM.AND.KP.lt.KM) then
        Z = 2.d0 / dsqrt(PP * KM)
       VP = -pp * k1 * Z
       VM = -p1 * km * Z
       V1 = -p1 * k1 * Z
       V2 = -pp * km * Z
      ElseIf(PP.lt.PM.AND.KP.ge.KM) then
        Z = 2.d0 / dsqrt(PM * KP)
       VP = -p2 * kp * Z
       VM = -pm * k2 * Z
       V1 = -p2 * k2 * Z
       V2 = -pp * km * Z
      ElseIf(PP.lt.PM.AND.KP.lt.KM) then
        Z = 2.d0 / dsqrt(PM * KM)
       VP = p2 * k1 * Z
       VM = pm * km * Z
       V1 = pm * k1 * Z
       V2 = p2 * km * Z
      EndIF
*
      v(1,3) = VP
      v(1,4) = V2
 
      v(2,3) = V1
      v(2,4) = VM
      RETURN
      END
